#!/bin/sh

APP=$(readlink -e $0)
[ "$APP" ] || APP=$0
APPDIR=$(dirname "$APP")
[ "$APPDIR" = "." ] && APPDIR=$(pwd)
export APPDIR="$APPDIR"

MO_DIR="/usr/share/locale"
MO_MY_DIR="$APPDIR/locale"
cp -a $MO_MY_DIR/* $MO_DIR

export TEXTDOMAIN=Chromium-MyPortable
export OUTPUT_CHARSET=UTF-8

# which gtkdialog
for P in gtkdialog4 gtkdaialog3 gtkdialog; do
  which $P &>/dev/null && GTKDIALOG=$P && break
done

ICON_DIR="$APPDIR/Template"
TEXT_WIDTH=350

export ChromiumMenuGui="
<window title=\"$(gettext " Wine_MyPortable menu ")\" resizable=\"true\" window_position=\"1\">
<vbox>
   <text width-request=\""$TEXT_WIDTH"\" use-markup=\"true\">
    <label>-----------------------------------------------</label>
   </text>
<hbox>
	<button>
      <input file>$ICON_DIR/gtk-preferences.png</input>
      <action>$APPDIR/AppRun --set-default </action>
   </button>
   <text width-request=\""$TEXT_WIDTH"\" use-markup=\"true\">
    <label>\"  Chromium をデフォルトブラウザにする。 \"</label>
   </text>
</hbox>
<hbox>
	<button>
      <input file>$ICON_DIR/gtk-preferences.png</input>
      <action>$APPDIR/AppRun --register</action>
   </button>
   <text width-request=\""$TEXT_WIDTH"\" use-markup=\"true\">
    <label>\"  Chromium をパピーメニューに登録する。\" </label>
   </text>
</hbox>
<hbox>
   <button>
    <input file>$ICON_DIR/gtk-open.png</input>
    <action>$APPDIR/AppRun --open</action>
   </button>
   <text width-request=\""$TEXT_WIDTH"\" use-markup=\"true\">
    <label>\"  内部Downloadsフォルダを開く。 \"</label>
   </text>
</hbox>

<hbox>
   <button>
    <input file>$ICON_DIR/gtk-clear.png</input>
    <action>$APPDIR/AppRun --clean</action>
   </button>
   <text width-request=\""$TEXT_WIDTH"\" use-markup=\"true\">
    <label>\"  ディスク・キャッシュを消去する。 \"</label>
   </text>
</hbox>

	<text width-request=\""$TEXT_WIDTH"\" use-markup=\"true\">
		<label>--------------------------------------------</label>
   </text>
  <hbox>
   <button cancel></button>
  </hbox>

</vbox>
</window>
"

eval $($GTKDIALOG --program=ChromiumMenuGui --center)

exit 1

