// xhr get abort

var SITEINFO_URL = 'http://wedata.net/databases/AutoPagerize/items_all.json'
var CACHE_EXPIRE = 24 * 60 * 60 * 1000

var siteinfo = JSON.parse(localStorage.cache || '{}').info || []
refreshSiteinfo(function(err, val) {
    siteinfo = val
})
var res = {}
res.load = function(req, sender, sendResponse) {
    var r = []
    if (req.url) {
        r = siteinfo.filter(function(i) {
            try {
                return req.url.match(i.url)
            }
            catch(e) {
                // console.log('err', e)
            }
        })
    }
    sendResponse({ val: r })
}
chrome.extension.onMessage.addListener(function(req, sender, sendResponse) {
    res[req.type] && res[req.type](req, sender, sendResponse)
})

function refreshSiteinfo(opt, callback) {
    opt = opt || {}
    var cache = JSON.parse(localStorage.cache || '{}')
    if (opt.force || !cache.expire ||
        (cache.expire && new Date(cache.expire) < new Date())) {
        get(SITEINFO_URL, function(err, val) {
            if (err) {
                callback && callback(err)
            }
            var info = reduceWedataJSON(JSON.parse(val))
            if (info.length > 0) {
                console.log(info.length)
                localStorage.cache = JSON.stringify({
                    expire: new Date().getTime() + CACHE_EXPIRE,
                    info: info
                })
                callback && callback(null)
            }
        })
    }
}

function get(url, callback) {
    var xhr = new XMLHttpRequest()
    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4) {
            if (xhr.status == 200) {
                callback(null, xhr.responseText)
            }
            else {
                callback(xhr.status, xhr.responseText)
            }
        }
    }
    xhr.open('GET', url, true)
    xhr.send(null)
    return xhr
}

function reduceWedataJSON(data) {
    var r_keys = ['url', 'nextLink', 'insertBefore', 'pageElement']
    var info = data.map(function(i) {
        return i.data
    }).filter(function(i) {
        return ('url' in i)
    })
    if (info.length === 0) {
        return []
    }
    else {
        info.sort(function(a, b) {
            return (b.url.length - a.url.length)
        })
        return info.map(function(i) {
            var item = {}
            r_keys.forEach(function(key) {
                if (i[key]) {
                    item[key] = i[key]
                }
            })
            return item
        })
    }
}

// Add X-Redirect-Final-URL
var redirects = {}
chrome.webRequest.onBeforeRedirect.addListener(
    function (details) {
console.log('redirect', details)
        redirects[details.requestId] = details.redirectUrl
    },
    { urls: ["<all_urls>"], types: ["xmlhttprequest"] }
)
chrome.webRequest.onHeadersReceived.addListener(
    function(details) {
        if (redirects[details.requestId]) {
            details.responseHeaders.push({
                name: 'X-Redirect-Final-URL',
                value: redirects[details.requestId]
            })
            return { responseHeaders: details.responseHeaders }
        }
    },
    { urls: ["<all_urls>"], types: ["xmlhttprequest"] },
    ["blocking", "responseHeaders"]
)
chrome.webRequest.onCompleted.addListener(
    function (details) {
        if (redirects[details.requestId]) {
            delete redirects[details.requestId]
        }
    },
    { urls: ["<all_urls>"], types: ["xmlhttprequest"] }
)
