//  isolate
//  =======
    (function ()
    {
        //  log
        var _log = function (_message) { if (console && console.log) { console.log('evernote_clearly / js_in_page / ' + _message); } };
    
        //  init -- gets executed when page is ready
        var _init = function ()
        {
            //  path
            var _path_main = 'chrome-extension://iooicodkiihhpojmmeghjclgihfjdjhj/';

            //  css IDs
            var _cssIDs = { 'prefix': 'evernote_clearly__' };
                _cssIDs.js_in_isolation = _cssIDs.prefix + 'js_in_isolation';
                _cssIDs.js_in_page = _cssIDs.prefix + 'js_in_page';

            //  containers
            var _html = document.getElementsByTagName('html')[0],
                _body = document.getElementsByTagName('body')[0];

            //  check containers
            if (_body) {}else { _log('page is missing body element'); return; }
            if (_html) {}else { _log('page is missing html element'); return; }

            //  js_in_page
            //  ==========

                //  create frame
                var _frame = document.createElement('iframe'),
                    _frameHTML = ''                         +
                        '<!DOCTYPE html>'                   +
                        '<html id="html"><body id="body">'  +
                            '<script type="text/javascript" src="'+_path_main+'third_party/jquery/jquery.js">' +                 '</script>' +
                            ''                              +
                            '<script type="text/javascript" src="'+_path_main+'the_components/detect/detect.js">' +              '</script>' +
                            '<script type="text/javascript" src="'+_path_main+'the_components/next/next.js">' +                  '</script>' +
                            ''                              +
                            '<script type="text/javascript" src="'+_path_main+'js_in_page/init_and_call.js">' +                     '</script>' +
                        '</body></html>'                    +
                    '';
                    
                //  frame attributes
                _frame.setAttribute('id', _cssIDs.js_in_page);
                _frame.setAttribute('frameBorder', '0');
                _frame.setAttribute('allowTransparency', 'true');
                _frame.setAttribute('scrolling', 'auto');

                //  set frame style
                _frame.style.position = 'fixed';
                _frame.style.width =    '5px';
                _frame.style.height =   '5px';
                _frame.style.top =      '-10px';
                _frame.style.left =     '-10px';

                //  insert frame
                _html.appendChild(_frame);
                
                //  write to frame -- when loaded        
                var _check_interval = false;
                var _check = function ()
                {
                    //  iframe
                    var _iframe = document.getElementById(_cssIDs.js_in_page);
                    if (_iframe) {}else { return; }

                    //  doc                
                    var _doc = (_iframe.contentDocument || _iframe.contentWindow.document);
                    if (_doc) {}else { return; }
                
                    //  clear interval
                    window.clearInterval(_check_interval);

                    //  write in frame                
                    _doc.open();
                    _doc.write(_frameHTML);
                    _doc.close();
                };
                _check_interval = window.setInterval(_check, 50);
        };

        //  try -- checks if page is ready and, if so, executes _init
        var _try = function (_delayedNrTimes)
        {
            //  not ready; try in 100ms
            if (document.readyState != 'complete' && _delayedNrTimes < 30)
            {
                //  again
                window.setTimeout(function () { _try(_delayedNrTimes + 1); }, 100);
                
                //  return
                return;
            }
        
            //  do -- finally
            _init();
        };

        //  go
        if (document.readyState) { _try(0); }
        else                     { _init(); }
        
    })();
