var API_KEY = "98cTNad3gaKf4Hbz31d0013dZ8p5GG5f";       // APIキー
var API_KEY_UPDATE = "4cFTZV86g1cFurzO46d84e6x0xp3U6fY"
var _bgPage = chrome.extension.getBackgroundPage();     // BackgroundPage
var _marksCount = 0;                                    // 既読チェック数
var _busy = false;                                      // 読み込み中
var _isTagEditMode = false;                             // タグ編集モード
var _readState;                                         // 未読(Unread)/既読(Read)状態
var _searchCache;
var _showSearchBox = false;

// クリック時の振る舞い
var click_behavior = {
    // バックグラウンドタブで開く
    OPEN_BG_TAB: "0",
    // フォアグラウンドタブで開く
    OPEN_FG_TAB: "1",
    // 開くと同時に既読チェック
    OPEN_AND_MARKASREAD: "2"
};

//------------------------------------------------
// 未読/既読状態取得
//------------------------------------------------
function getReadState() {
    if (_readState == "read") {
        return "read";
    } else {
        return "unread";
    }
}

//------------------------------------------------
// 初期化(呼び出し前に_readStateを設定することで未読/既読切り替え
//------------------------------------------------
function initList() {
    hideSearchBox();
    if (_isTagEditMode) { exitTagEditMode(); }
    
    _marksCount = 0;
    _isTagEditMode = false;
    enableSendMarkAsReadButton(false);
    
    if (getReadState() == "search") {
        searchMode();
        return false;
    }

    loading.Start();
    
    $("#list").empty()
        .append($("<div />").attr("id", "readnext").text("--- loading ---"))
        .append($("<ul />"));
    
    // ReadingList更新中だったら待つ
    wait(function() {
        readNext(1);
        $("#list").scroll(function () { autopager(); });
    });  
        
}

//------------------------------------------------
// 更新完了待ち
//------------------------------------------------
function wait(f, timer) {
    if (timer != undefined) { clearTimeout(timer); }
    if (_bgPage._updating) {
        timer = setTimeout(function(){ wait(f, timer); }, 100);
    } else {
        f();
    }
}

//------------------------------------------------
// 検索ボックス表示
//------------------------------------------------
function showSearchBox() {
    var searchForm = $("#searchform");
        if (searchForm.length == 0) { 
        searchForm = $("<form />").attr("id", "searchform")
            .append($("<div />")
                .append($("<span />").addClass("label").text("Title"))
                .append($("<input />").attr("id", "search_keyword").attr("type", "search")))
             .hide();
        var taglist = $("<select />").attr("id", "search_tags").append($("<option />").attr("value", "").text(""));
        
        $.each(_bgPage._taglist, function(i, tag) {
            taglist.append($("<option />").attr("value", tag).text(tag));
        });
        
        searchForm.append($("<div />")
            .append($("<span />").addClass("label").text("Tags"))
            .append(taglist))
            .append($("<input />").attr("id", "search_unread").attr("type", "checkbox").attr("name", "target_list")
                .after($("<label />").attr("for", "search_unread").text("Unread")))
            .append($("<input />").attr("id", "search_read").attr("type", "checkbox").attr("name", "target_list")
                .after($("<label />").attr("for", "search_read").text("Read")))
            
            .append($("<input />").attr("id", "search_exec").attr("type", "submit").attr("value", "Search"))
            .submit(function() {
                wait(function() {
                    execSearch(1);
                    $("#list").scroll(function () { autopager(); });
                });
                return false;  
            });
        //$("#list").addClass("search").before(searchForm);
           
        $("#list > ul").before(searchForm)
        var statetype = getReadState() == "unread" ? $("#search_unread") : $("#search_read");
        statetype.attr("checked", "checked");
    }
    searchForm.slideDown(100);
    $("#search_keyword").focus();
    
    $("#list > ul").one("click", hideSearchBox);
    
    _showSearchBox = true;
}

//------------------------------------------------
// 検索ボックス非表示
//------------------------------------------------
function hideSearchBox() {
    $("#searchform").slideUp(100, function() {
        //$("#searchform").remove();
        //$("#list").removeClass("search");
    });
    _showSearchBox = false;
}

//------------------------------------------------
// 検索実行
//------------------------------------------------
function execSearch(page) {
    
    if (_busy) {
        return false;
    }

    _busy = true;
    loading.Start();
        
    if (page == 1) {
        var search_unread = $("#search_unread").prop("checked");
        var search_read = $("#search_read").prop("checked");
        var keyword = $("#search_keyword").val();
        var tag = $("#search_tags").val();
        
        var searchState = "";
        if (search_unread && !search_read) { 
            searchState = "0";
        } else if (!search_unread && search_read) {
            searchState = "1";        
        }
        
        var titlematch = new RegExp(keyword, "i");
        // キャッシュから件数分を取得
        _searchCache = $.grep(_bgPage._readlist, function(value, index) {
            if (searchState != "" && value.state != searchState) {
                return false;
            }
            
            var tagstr = value.tags;
            if (tag != "" && tagstr == undefined) {
                return false;
            } else if (tag != "") {
                var tags = tagstr.split(",");
                if (tags.indexOf(tag) == -1) {
                    return false;
                }
            }
            
            return value.title.match(titlematch);        
        });
        $("#list > ul > *").remove();
    }
    
    if (_searchCache.length > 0) {
        var readlist = _searchCache.slice((page - 1) * localStorage.readcount, page * localStorage.readcount);
        createList(readlist);
        $("#readnext").remove();
        
        if (page * localStorage.readcount >= _searchCache.length) {
            // リストがなかったらreadnextを無効に
            $("#list > ul > hr:last").remove();
            $("#list").unbind("scroll");
        } else {
            page++;
            $("#list")
                 .append($("<div />")
                 .attr("id", "readnext")
                 .one("click", function () { execSearch(page) })
                 .text("--- read next ---"));
        }   
    }
    
    _busy = false;
    loading.End();
}

//------------------------------------------------
// ReadingListの続きを取得
//------------------------------------------------
function readNext(page, state) {
    if (_busy) {
        return false;
    }

    if (_bgPage._ex != undefined && _bgPage._readlist == undefined) {
        loadError(_bgPage._ex);
        loading.End();
        return false;
    }

    _busy = true;
        
    loading.Start();
    
    var readstate = getReadState() == "unread" ? "0" : "1";
    
    // キャッシュから件数分を取得
    var readlist = $.grep(_bgPage._readlist, function(value, index) {
        return value.state == readstate;
    });
    readlist = readlist.slice((page - 1) * localStorage.readcount, page * localStorage.readcount);
    
    addList(readlist, page);
    _busy = false;
    loading.End();
}

//------------------------------------------------
// 取得したReadingListを画面に設定
//------------------------------------------------
function addList(list, page) {
    if (list.length == 0) {
        // リストがなかったらreadnextを無効に
        $("#list > ul > hr:last").remove();
        $("#list").unbind("scroll");
        return false;
    }
    
    // DOM生成
    createList(list);
    $("#readnext").remove();

    // Statusからアイテム数取得
    var allItems = (getReadState() == "unread") ? _bgPage._accountStatus.count_unread : _bgPage._accountStatus.count_read;
    
    // リスト中の件数
    var fetchedItems = $("#list ul li").size();
    if (allItems <= fetchedItems) {
        // 全て読み込んだらreadnextを無効に
        $("#list > ul > hr:last").remove();
        $("#list").unbind("scroll");
        return false;
    }

    // readnextを設定
    page++;
    $("#list")
         .append($("<div />")
         .attr("id", "readnext")
         .one("click", function () { readNext(page) }).text("--- read next ---"))
}

//------------------------------------------------
// ReadingListのDOM構築
//------------------------------------------------
function createList(data) {
    var list = $("#list > ul");
    $.each(data, function () {
        var item_id = this.item_id; // ID
        var title = this.title; // タイトル
        var url = this.url; // URL
        var tags = this.tags == undefined ? "" : this.tags;
        var readstate = this.state;
        var domainArray = url.split('/').splice(0, 3);
        var domainName = domainArray[2];
        var domainUrl = domainArray.join('/');
        var favicon_id = "favicon_" + item_id;

        var li = $("<li />").attr("id", item_id).data("url", url);
        var favicon_div = $("<div />").addClass("favicon");
        var favicon_img = $("<img />").hide()
                .attr("id", favicon_id)
                .attr("src", domainUrl + "/favicon.ico")
                .attr("width", 16)
                .attr("height", 16)
                .one("load", function () {
                    favicon_img.show();
                })
                .error(function () {
                    favicon_img.attr("src", "chrome://favicon/" + url);
                });
        li.append(favicon_div.append(favicon_img));
        var listitem = $("<a />").attr("href", "#").click(function () { openLink(url, item_id) }).text(title);
        if (title == '') {
            listitem.text(url);
            if (localStorage.fetchtitle != "false") {
                fetchTitle(listitem, url);
            }
        }

        li.append($("<div />").addClass("listitem").append(listitem));

        var domain = $("<div />").addClass("domain").append($("<a />").attr("href", "#").click(function () { openLink(domainUrl) }).text(domainName));
        if (localStorage.showdomain == "false") {
            domain.hide();
        }
        li.append(domain);

        var tagForm = $("<input />").attr("type", "text").data("tags", tags).change(function () {
            var editTagButton = $("#edit_tags > a");
            if (!editTagButton.hasClass("button_hilight")) {
                $("#edit_tags > a").removeClass("button").addClass("button_hilight");
            }
        });
        if (tags != undefined) {
            tagForm.val(tags);
        }
        var tagEditor = $("<div />").addClass("tag_editor").append(tagForm);
        if (!_isTagEditMode) {
            tagEditor.addClass("tag_editor_disabled").filter("input");
            tagForm.attr("disabled", "disabled");
            if (localStorage.alwaysshowtags == "false") {
                tagEditor.hide();
            }
        }
        li.append(tagEditor);

        if (readstate == "0") {
            li.append($("<div />").attr("id", "mark_" + item_id).addClass("markasread").data("checked", "false").click(function () { markAsRead(this) }));
        }
        list.append(li);
        list.append($("<hr />"));        
    });
}

//------------------------------------------------
// ページタイトル取得
//------------------------------------------------
function fetchTitle(target, url) {
    $.get(url)
        .done(function (data, status) {
            var title = getTitleText(data);
            if (title == null) { title = url; }
                
            target.text(title);
        })
        .fail(function (e) { });
}

//------------------------------------------------
// アイテムクリック時の動作
//------------------------------------------------
function openLink(url, item_id) {
    var page;
    switch (event.button) {
        case 0: // 左クリック
            page = setOpenLinkParameter(localStorage.behavior_lbutton, url, item_id);
            break;
        case 1: // 中クリック
            page = setOpenLinkParameter(localStorage.behavior_mbutton, url, item_id);
            break;
        default:
            return false;
    }

    chrome.tabs.create(page, function(tab) {
        _bgPage._openUnread[tab.id] = url;
    });
}

//------------------------------------------------
// 新規タブパラメータ生成
//------------------------------------------------
function setOpenLinkParameter(behavior, url, item_id) {
    var page = {
        url: url,
        selected: false
    };
    switch (behavior) {
        case click_behavior.OPEN_BG_TAB:
            break;
        case click_behavior.OPEN_FG_TAB:
            page.selected = true;
            break;
        case click_behavior.OPEN_AND_MARKASREAD:
            if (item_id != undefined) {
                var markasread = $("#mark_" + item_id);
                if (markasread.data("checked") == "false") {
                    markasread.click();
                }
            }
        break;
    }
    return page;
} 

//------------------------------------------------
// フィルタリング
//------------------------------------------------
function filtering(filterinput) {
    var filterstr = $.trim(filterinput.value);
    var list = $("#list li:not(#nextread)");
    if (filterstr.length == 0) {
        list.show();
        $("#list hr").show();
    }
    var filterstrlist = filterstr.split(" ");
    list.each(function () {
        var item = $(this);
        item.show();
        var title = $("div.listitem a", this).text();
        var tagstr = $("div.tag_editor input", this).data("tags");
        var tags;
        if (tagstr != undefined) {
            tags = tagstr.split(",");
        }
        for (var i = 0; i < filterstrlist.length; i++) {
            var exp = new RegExp(filterstrlist[i], "i");

            var tagMatched = false;
            if (tagstr != undefined) {
                for (var j = 0; j < tags.length; j++) {
                    if (tags[j].match(exp)) {
                        tagMatched = true;
                    }
                }
            }

            if (!title.match(exp) && !tagMatched) {
                item.hide();
                var next = item.next();
                if (next.is("hr")) {
                    next.hide();
                }
            }
        }
    }); 
}

//------------------------------------------------
// !!! 新規追加(未使用)
//------------------------------------------------
function addNewUrl() {
    loading.Start();
    chrome.tabs.getSelected(null, function (tab) {
        var params = {
            username: localStorage.username,
            password: localStorage.password,
            apikey: API_KEY_UPDATE,
            url: tab.url,
            title: tab.title
        };

        $.get("https://readitlaterlist.com/v2/add", params)
        .done(function (data, status) { _bgPage.updateBadgeText(); })
        .fail(function (e) { loadError(e); })
        .always(function () { loading.End(); });
    });
}

//------------------------------------------------
// タグ編集モード開始
//------------------------------------------------
function enterTagEditMode() {
    var tagEditor = $("#list > ul > li > div.tag_editor");
    tagEditor.removeClass("tag_editor_disabled").find("input").removeAttr("disabled");
    if (localStorage.alwaysshowtags == "false") {
        tagEditor.slideDown(300);
    }
    $("#edit_tags").unbind("click").click(saveTags);
    $("#edit_tags > a").text("Save Tags");
    _isTagEditMode = true;
}

//------------------------------------------------
// タグ編集モード終了
//------------------------------------------------
function exitTagEditMode() {  
    var tagEditor = $("#list > ul > li > div.tag_editor");
    tagEditor.addClass("tag_editor_disabled").find("input").attr("disabled", "disabled");
    if (localStorage.alwaysshowtags == "false") {
        tagEditor.slideUp(300);
    }
    $("#edit_tags").unbind("click").click(enterTagEditMode);
    $("#edit_tags > a").text("Edit Tags").removeClass("button_hilight").addClass("button");
    _isTagEditMode = false;
}

//------------------------------------------------
// タグ保存
//------------------------------------------------
function saveTags() {
    loading.Start();
    var list = $("#list > ul > li");

    var update_tags = "{";
    var i = 0;
    list.each(function () {
        var input = $("div.tag_editor input", this);
        var newTags = input.val();
        var oldTags = input.data("tags");
        if (newTags != oldTags) {
            if (i > 0) { update_tags += "," };
            update_tags += "\"" + i + "\":{\"url\":\"" + $(this).data("url") + "\",\"tags\":\"" + tagValidation(newTags) + "\"}";
            i++;
        }
    });
    update_tags += "}";
    if (i > 0) {
        var params = {
            username: localStorage.username,
            password: localStorage.password,
            apikey: API_KEY_UPDATE,
            update_tags: update_tags
        }

        $.get("https://readitlaterlist.com/v2/send", params)
            .done(function (data, status) {
                if (status == "success") {
                    $("#list > ul > li.exec_markasread").hide();
                    _bgPage.autoRefresh.Reset();
                    initList();
                } else {
                    loadError(status);
                }                
            })
            .fail(function (e) { loadError(e); })
            .always(function () { loading.End(); });
    } else {
        loading.End();
    }
    exitTagEditMode()
}

//------------------------------------------------
// 既読チェック処理
//------------------------------------------------
function markAsRead(target) {
    var checked = $(target).data("checked");
    if (checked == "false") {
        $(target).data("checked", "true");
        _marksCount++;
        $(target).addClass("markasread_checked");
    } else {
        $(target).data("checked", "false");
        _marksCount--;
        $(target).removeClass("markasread_checked");
    }

    if (_marksCount > 0) {
        enableSendMarkAsReadButton(true);
    } else {
        enableSendMarkAsReadButton(false);
    }
}

//------------------------------------------------
// 既読情報更新
//------------------------------------------------
function sendMarkAsRead() {
    loading.Start();
    var urls = "{";
    var i = 0;
    $("#list > ul > li").filter(function () {
        return $("div.markasread", this).data("checked") == "true"
    }).each(function () {
        if (i > 0) { urls += "," };
        urls += "\"" + i + "\":{\"url\":\"" + $(this).data("url") + "\"}";
        i++;
        $(this).addClass("exec_markasread");
        var next = $(this).next();
        if (next.is("hr")) {
            next.addClass("exec_markasread");
        }
    });

    urls += "}";

    if (i > 0) {
        var params = {
            username: localStorage.username,
            password: localStorage.password,
            apikey: API_KEY_UPDATE,
            read: urls
        }

        $.get("https://readitlaterlist.com/v2/send", params)
            .done(function (data, status) {
                if (status == "success") {
                    $("#list > ul > li.exec_markasread").hide();
                    $("#list > ul > hr.exec_markasread").hide();
                    _bgPage.autoRefresh.Reset();
                }
            })
            .fail(function (e) { loadError(e); })
            .always(function () { loading.End(); });
        } else {
        loading.End();
    }
    _marksCount = 0;
    enableSendMarkAsReadButton(false);
}

//------------------------------------------------
// 既読チェックボタン切り替え
//------------------------------------------------
function enableSendMarkAsReadButton(enable) {
    if (enable) {
        var markasread = $("#send_markasread > a");
        markasread.text("Mark " + _marksCount + " as Read");
        if (!markasread.hasClass("button")) {
            $("#send_markasread").click(sendMarkAsRead);
            markasread.addClass("button").addClass("button_hilight").removeClass("button_disable");
        }
    } else {
        $("#send_markasread").unbind("click");
        $("#send_markasread > a").text("Mark as Read")
            .addClass("button_disable").removeClass("button").removeClass("button_hilight");
    }
}

//------------------------------------------------
// ステータスメッセージ表示
//------------------------------------------------
function showStatus(message) {
    var status = $("#status");
    status.html(message);
    status.show();
    status.fadeOut(1000);
}

//------------------------------------------------
// エラー処理
//------------------------------------------------
function loadError(e) {
    var err_result = $("#<div />").addClass("errormsg")
        .append($("<p />").text(e.responseText))
        .append($("<p />").html("Check account settings::(<a href=\"options.html\" target=\"_blank\">option</a>)"));
    $("#list").html(err_result);
}

//------------------------------------------------
// AutoPagerize
//------------------------------------------------
function autopager() {
    if ($("#list > ul").height() - $("#list").scrollTop() < $("#list").height()) {
        $("#readnext").click();
    }
}

//------------------------------------------------
// ロードアイコン表示
//------------------------------------------------
loading = {
    Start: function () { $("#loading_background").show(); $("#loading").show(); console.log("loading.Start"); },
    End: function () { $("#loading_background").hide(); $("#loading").hide(); console.log("loading.End"); }
};


//------------------------------------------------
// JSONデータの配列化
//------------------------------------------------
convertToArray = function (list) {
    var list_str = JSON.stringify(list);
    list_str = list_str.replace("{", "[");
    list_str = list_str.replace("}}", "}]");

    list_str = list_str.replace(/\"[0-9]+\":/g, "");

    var list_array = JSON.parse(list_str);
    return list_array;
};

//------------------------------------------------
// ソート
//------------------------------------------------
sort = {
    Old: function (a, b) {
        if (a.time_updated > b.time_updated)
            return 1;
        else if (a.time_updated < b.time_updated)
            return -1;
        return 0;
    },

    New: function (a, b) {
        if (a.time_updated > b.time_updated)
            return -1;
        else if (a.time_updated < b.time_updated)
            return 1;
        return 0;
    }
};

//------------------------------------------------
// タグ書式チェック
//------------------------------------------------
tagValidation = function (str) {
    var reg = new RegExp(/["'{}[\]]/g);
    return str.replace(reg, "");
}


//------------------------------------------------
// タイトルテキスト取得
//------------------------------------------------
function getTitleText(data) {
    var title = null;
    var titletag = $(/<title[\s\S]*\/title>/i.exec(data)[0]);
    if (titletag != undefined && titletag.length > 0 && titletag[0].constructor.name == "HTMLTitleElement") {
        title = titletag.text().replace(/[\n\r]*/g, "");
        title = $.trim(title);                        
    }
    
    return title;
}