function log(msg) {
    console.log(msg);
}

function save_options(dict) {
    var key = "";
    for(key in dict) {
        localStorage[key] = dict[key];
    }
}

function restore_options(key) {
    var value = localStorage[key];
    return value;
}

function stopPlayer() {
    document.getElementById("radiko_player").src = "about:blank";
    chrome.browserAction.setBadgeText({"text":""});
    if(stID) { clearTimeout(stID); }  // showDesktopnotifications()
}

function setChannel(channel) {
    if(!channel) {
        var channel = getChannel();
    }
    save_options({"radiko_channel": channel});
    document.getElementById("radiko_player").src = "about:blank";
    chrome.browserAction.setBadgeText({"text":channel});
    // radiru
    if(channel == "r1" || channel == "r2" || channel == "fm") {
        document.getElementById("radiko_player").src =
            "http://www3.nhk.or.jp/netradio/player/index.html?"+channel;
    } else {
        document.getElementById("radiko_player").src =
            "http://radiko.jp/#"+channel;
        document.getElementById("radiko_player").src =
            "http://radiko.jp/#"+channel;
        showDesktopnotifications();
    }
    // radiru end
}

function getChannel() {
    var channel = restore_options("radiko_channel");
    if(!channel) {
        channel = "TBS";
    }
    return channel;
}

function getRegion(reload) {
    var region = restore_options("radiko_region");
    var area = restore_options("radiko_area");
    if(reload || (!region && !area)) {
        var xhr = new XMLHttpRequest();
        // xhr.setRequestHeader("Pragma", "no-cache");
        // xhr.setRequestHeader("Cache-Control", "no-cache");
        // xhr.setRequestHeader("Expires", "Thu, 01 Jan 1970 00:00:00 GMT");
        xhr.open("GET", "http://radiko.jp/station/", false);
        xhr.send(null);
        var station_xml = xhr.responseXML;
        var stations_elem = station_xml.getElementsByTagName("stations")[0];
        region = stations_elem.attributes["area_id"].textContent;
        // region = "JP13";
        area = stations_elem.attributes["area_name"].textContent;
        // area = "TOKYO JAPAN";
        save_options({"radiko_region": region, "radiko_area": area});
    }
    return {"region":region, "area":area};
}

function getStations(elem) {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", "http://radiko.jp/v2/station/list/" +
             getRegion(false)["region"] + ".xml", true);
    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4 && xhr.status == 200) {
            var station_xml = xhr.responseXML;
            var area_name = station_xml.getElementsByTagName("stations")[0]
                .attributes["area_name"].textContent;
            var station_group = document.createElement("optgroup");
            station_group.setAttribute("label", area_name);
            var channel = getChannel();
            var stations = station_xml.getElementsByTagName("station");
            for(var i = 0; i < stations.length; i++) {
                var station_id = stations[i].getElementsByTagName("id")[0].textContent;
                var station_name = stations[i].getElementsByTagName("name")[0].textContent;
                var station = document.createElement("option");
                station.setAttribute("value", station_id);
                if(station_id == channel) {
                    station.selected = "true";
                }
                station.innerHTML = station_name + " (#" + station_id + ")";
                station_group.appendChild(station);
            }
            // radiru
            var radiru_group = document.createElement("optgroup");
            radiru_group.setAttribute("label", "らじる★らじる");
            var radiru_stations = {
                "r1": "NHK ラジオ第1", "r2": "NHK ラジオ第2",
                "fm": "NHK FM"
            };
            for(var s in radiru_stations) {
                var station = document.createElement("option");
                station.setAttribute("value", s);
                if(s == channel) {
                    station.selected = "true";
                }
                station.innerHTML = radiru_stations[s] + " (#" + s + ")";
                radiru_group.appendChild(station);
            }
            elem.appendChild(station_group);
            elem.appendChild(radiru_group);
        }
    }
    xhr.send(null);
}

function isShowtimetable() {
    var show = restore_options("radiko_showtimetable");
    if(!show || show == "OFF") {
        return false;
    } else {
        return true;
    }
}

function isNowonair() {
    var nowonair = restore_options("radiko_nowonair");
    if(nowonair == "OFF") {
        return false;
    } else {
        return true;
    }
}

function getNowonair(station_id, elem) {
    var nowonair_url = "http://radiko.jp/station/feed/"+ station_id +"/feed.xml";
    var xhr = new XMLHttpRequest();
    xhr.open("GET", nowonair_url, false);
    xhr.send(null);
    var nowonair_xml = xhr.responseXML;
    var items = nowonair_xml.getElementsByTagName("item");
    var nowonair_text = "";
    for(var i = 0; i < items.length; i++) {
        item = items[i];
        if(item.attributes["type"].textContent == "music") {
            var artist = item.attributes["artist"].textContent;
            var title = item.attributes["title"].textContent;
            var time = item.attributes["stamp"].textContent.slice(11, 16);
            nowonair_text = artist + " &#65378;" + title + "&#65379; (" + time + ")";
            break;
        }
    }
    elem.innerHTML = nowonair_text;
}

function isPlaying() {
    var src = document.getElementById("radiko_player").src;
    if(src == "about:blank") {
        return false;
    } else {
        return true;
    }
}

function getPlayer() {
    return document.getElementById("radiko_player").outerHTML;
}

function showTimetable(elem, prefunc, postfunc) {
    prefunc();
    var channel = getChannel();
    if(channel == "r1" || channel == "r2" || channel == "fm") {
        showRadiruTimetable(elem);
    } else {
        showRadikoTimetable(elem);
    }
    postfunc();
}

function showRadikoTimetable(elem) {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", "http://radiko.jp/v2/api/program/today?area_id=" +
             getRegion(false)["region"], true);
    // mode=today, mode=tomorrow
    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4 && xhr.status == 200) {
            var info_xml = xhr.responseXML;
            var table_elem = document.createElement("table");
              var col1_elem = document.createElement('col');
              col1_elem.setAttribute("width", "90");
              var col2_elem = document.createElement('col');
              col2_elem.setAttribute("width", "410");
              table_elem.appendChild(col1_elem);
              table_elem.appendChild(col2_elem);            
            var stations = info_xml.getElementsByTagName("station");
            for(var i = 0; i < stations.length; i++) {
                var station = stations[i];
                var station_id = station.attributes["id"].textContent;
                var station_name = station.getElementsByTagName("name")[0].textContent;
                var station_elem = document.createElement("tr");
                station_elem.setAttribute("id", "station_"+station_id);
                station_elem.setAttribute("class", "station_name");
                station_elem.setAttribute("onmouseover",
                                          "showHidingprog('" + station_id + "')");
                station_elem.setAttribute("onmouseout",
                                          "hideShowingprog('" + station_id + "')");
                if(isPlaying()) {
                    if(getChannel() == station_id) {
                        station_elem.style.backgroundColor = "#FFCC00";
                        station_elem.removeAttribute("onmouseout");
                    }
                }
                var station_info_elem = document.createElement("td");
                var station_name_elem = document.createElement("span");
                station_name_elem.innerHTML = "#" + station_id + " (" + station_name + ")";
                station_name_elem.setAttribute("onclick", "play(\"" + station_id + "\")");
                station_info_elem.appendChild(station_name_elem);
                station_info_elem.setAttribute("colspan", "2");
                station_info_elem.setAttribute("id", "station_info_"+station_id);
                station_elem.appendChild(station_info_elem);
                /*
                 var _td = station.getElementsByTagName("progs")[0].attributes["date"].textContent;
                 var today = new Array(_td.slice(0, 4), _td.slice(4,6), _td.slice(6,8)).join("/");
                 var station_today_elem = document.createElement("td");
                 station_today_elem.innerHTML = today;
                 station_today_elem.setAttribute("class", "station_today");
                 station_elem.appendChild(station_today_elem);
                 */
                if(isNowonair()) {
                    if(station_id == "INT" || station_id == "FMT" || station_id == "FMJ" ||
                       station_id == "CCL" ||  station_id == "802" ||  station_id == "FMO") {
                        station_info_elem.innerHTML += "<span style=\"font-size:7px; margin-left:10px;\">\
                        [<a onclick=\"showNowonair('" + station_id + "')\">&#x266a;</a>]</span>\
                            <marquee scrolldelay=\"130\" id=\"nowonair_" +
                            station_id + "\"></marquee>";
                    }
                }
                table_elem.appendChild(station_elem);
                var progs = station.getElementsByTagName("prog");
                var nowTime = new Date();
                var nowHM = parseInt(nowTime.getHours() + ("0" + nowTime.getMinutes()).slice(-2));
                var progNum = -1;
                var proc_target = false;
                for(var j = 0; j < progs.length; j++) {
                    var prog = progs[j];
                    var _ftl = prog.attributes["ftl"].textContent;
                    var _tol = prog.attributes["tol"].textContent;
                    if(progNum != 0) {
                        if(progNum == 1) {
                            break;
                        }
                        if(nowHM >= parseFloat(_ftl) && nowHM <= parseFloat(_tol)) {
                            proc_target = true;
                        }
                    } else {
                        proc_target = true;
                    }
                    if(! proc_target) continue;
                    progNum += 1;
                    var prog_ftl = new Array(_ftl.slice(0,2), _ftl.slice(2,4)).join(":");
                    var prog_tol = new Array(_tol.slice(0,2), _tol.slice(2,4)).join(":");

                    var prog_title = prog.getElementsByTagName("title")[0].textContent;
                    var prog_pfm = "";
                    try {
                        prog_pfm = prog.getElementsByTagName("pfm")[0].textContent;
                        if(prog_pfm.length > 45) {
                            prog_pfm = prog_pfm.substr(0, 45) + "&#8230;";
                        }
                    } catch(e) {
                        prog_pfm = "?";
                    }
                    var prog_desc = "";
                    try {
                        prog_desc = prog.getElementsByTagName("desc")[0].textContent;
                    } catch(e) {
                        prog_desc = "";
                    }
                    try {
                        prog_desc += "<br />" + prog.getElementsByTagName("info")[0].textContent;
                    } catch(e) {}
                    var prog_url = "";
                    try {
                        var url = prog.getElementsByTagName("url")[0].textContent;
                        if(url != "") {
                            prog_url = " [<a href=\"" + url +
                                "\" title=\"" + url + "\" target=\"_blank\">&#9758;</a>]"
                            // &#10162;
                        }
                    } catch(e) {
                        prog_url = "";
                    }
                    var prog_elem = document.createElement("tr");
                    prog_elem.setAttribute("class", "prog_item");
                    prog_elem.setAttribute("id", station_id + "_" + progNum);
                    var prog_tl_elem = document.createElement("td");
                    prog_tl_elem.innerHTML = prog_ftl + " &#12316; " + prog_tol;
                    prog_tl_elem.setAttribute("class", "prog_tl");
                    prog_tl_elem.setAttribute("onclick", "play(\"" + station_id + "\")");
                    var prog_title_elem = document.createElement("td");
                    prog_title_elem.innerHTML = ("\"" + prog_title + "\"" +
                                                 " by " + prog_pfm + prog_url)
                        .replace(/<br ?\/?>/g, " &#8629; ");
                    prog_title_elem.setAttribute("title", prog_desc.replace(/<br ?\/?>/g, "\n"));
                    prog_title_elem.setAttribute("class", "prog_title");
                    // prog_tl_elem.setAttribute("style", "width: 90px;");
                    // prog_title_elem.setAttribute("style", "width: 410px;");
                    prog_elem.appendChild(prog_tl_elem);
                    prog_elem.appendChild(prog_title_elem);
                    prog_elem.setAttribute("onmouseover",
                                           "showHidingprog('" + station_id + "')");
                    prog_elem.setAttribute("onmouseout",
                                           "hideShowingprog('" + station_id + "')");
                    if(progNum == 1) {
                        prog_elem.style.display = "none";
                    }
                    if(isPlaying()) {
                        if(getChannel() == station_id) {
                            prog_elem.style.display = "table-row";
                            prog_elem.removeAttribute("onmouseout");

                        }
                    }
                    table_elem.appendChild(prog_elem);
                }
            }
            elem.innerHTML = "<hr />" + table_elem.outerHTML;
        }
    }
    xhr.send(null);
}

function showRadiruTimetable(elem) {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", "http://cgi4.nhk.or.jp/tvnavi/api/noa-nr.cgi?mode=jsonp", true);
    xhr.onreadystatechange = function() {
        if (xhr.readyState == 4 && xhr.status == 200) {
            var info = xhr.responseText;
            info = info.replace("nowonair(", "").replace(");", "");
            var info_json = JSON.parse(info);
            var table_elem = document.createElement("table");
              var col1_elem = document.createElement('col');
              col1_elem.setAttribute("width", "90");
              var col2_elem = document.createElement('col');
              col2_elem.setAttribute("width", "410");
              table_elem.appendChild(col1_elem);
              table_elem.appendChild(col2_elem);            
            var stations = info_json["items"];
            for(var i = 0; i < (stations.length) / 2; i++) {
                var station = stations[i * 2];
                var station_id = station["ch"].replace("net", "");
                var station_name = (station_id == "r1")? "NHK ラジオ第1":
                    (station_id == "r2")? "NHK ラジオ第2":
                    (station_id == "fm")? "NHK FM":  "NHK";
                var station_elem = document.createElement("tr");
                station_elem.setAttribute("id", "station_"+station_id);
                station_elem.setAttribute("class", "station_name");
                station_elem.setAttribute("onmouseover",
                                          "showHidingprog('" + station_id + "')");
                station_elem.setAttribute("onmouseout",
                                          "hideShowingprog('" + station_id + "')");
                if(isPlaying()) {
                    if(getChannel() == station_id) {
                        station_elem.style.backgroundColor = "#FFCC00";
                        station_elem.removeAttribute("onmouseout");
                    }
                }
                var station_info_elem = document.createElement("td");
                var station_name_elem = document.createElement("span");
                station_name_elem.innerHTML = "#" + station_id + " (" + station_name + ")";
                station_name_elem.setAttribute("onclick", "play(\"" + station_id + "\")");
                station_info_elem.appendChild(station_name_elem);
                station_info_elem.setAttribute("colspan", "2");
                station_info_elem.setAttribute("id", "station_info_"+station_id);
                station_elem.appendChild(station_info_elem);
                table_elem.appendChild(station_elem);
                for(var j = 0; j < 2; j++) {
                    var prog = stations[i * 2 + j];
                    var prog_title = prog["title"];
                    var prog_pfm = "";
                    try {
                        prog_pfm = prog["subtitle"];
                        if(prog_pfm.length > 45) {
                            prog_pfm = prog_pfm.substr(0, 45) + "&#8230;";
                        }
                    } catch(e) {
                        prog_pfm = "?";
                    }
                    var prog_desc = "";
                    try {
                        prog_desc = prog["free"];
                    } catch(e) {
                        prog_desc = "";
                    }
                    var prog_url = "";
                    try {
                        var url = prog["link"];
                        if(url != "") {
                            prog_url = " [<a href=\"" + url +
                                "\" title=\"" + url + "\" target=\"_blank\">&#9758;</a>]"
                            // &#10162;
                        }
                    } catch(e) {
                        prog_url = "";
                    }
                    var _ftl = prog["starttime"];
                    var _tol = prog["endtime"];
                    var prog_ftl = new Array(_ftl.slice(11,13), _ftl.slice(14,16)).join(":");
                    var prog_tol = new Array(_tol.slice(11,13), _tol.slice(14,16)).join(":");
                    var prog_elem = document.createElement("tr");
                    prog_elem.setAttribute("class", "prog_item");
                    prog_elem.setAttribute("id", station_id + "_" + j);
                    var prog_tl_elem = document.createElement("td");
                    prog_tl_elem.innerHTML = prog_ftl + " &#12316; " + prog_tol;
                    prog_tl_elem.setAttribute("class", "prog_tl");
                    prog_tl_elem.setAttribute("onclick", "play(\"" + station_id + "\")");
                    var prog_title_elem = document.createElement("td");
                    prog_title_elem.innerHTML = ("\"" + prog_title + "\"" +
                                                 " by " + prog_pfm + prog_url)
                        .replace(/<br ?\/?>/g, " &#8629; ");
                    prog_title_elem.setAttribute("title", prog_desc.replace(/<br ?\/?>/g, "\n"));
                    prog_title_elem.setAttribute("class", "prog_title");
                    // prog_tl_elem.setAttribute("style", "width: 90px;");
                    // prog_title_elem.setAttribute("style", "width: 410px;");
                    prog_elem.appendChild(prog_tl_elem);
                    prog_elem.appendChild(prog_title_elem);
                    prog_elem.setAttribute("onmouseover",
                                           "showHidingprog('" + station_id + "')");
                    prog_elem.setAttribute("onmouseout",
                                           "hideShowingprog('" + station_id + "')");
                    if(j != 0) {
                        prog_elem.style.display = "none";
                    }
                    if(isPlaying()) {
                        if(getChannel() == station_id) {
                            prog_elem.style.display = "table-row";
                            prog_elem.removeAttribute("onmouseout");

                        }
                    }
                    table_elem.appendChild(prog_elem);
                }
            }
            elem.innerHTML = "<hr />" + table_elem.outerHTML;
        }
    }
    xhr.send(null);
}

function getRadikoTimetableNow() {
    var channel = getChannel();
    var xhr = new XMLHttpRequest();
    xhr.open("GET", "http://radiko.jp/v2/api/program/today?area_id=" +
             getRegion(false)["region"], false);
    xhr.send(null);
    var info_xml = xhr.responseXML;
    var stations = info_xml.getElementsByTagName("station");
    var station_name = "";
    var prog_title = "";
    var prog_pfm = "";
    var prog_desc = "";
    var prog_url = "";
    var prog_ftl = "";
    var prog_tol = "";
    for(var i = 0; i < stations.length; i++) {
        if(channel == stations[i].attributes["id"].textContent) {
            var station = stations[i];
            station_name = station.getElementsByTagName("name")[0].textContent;
            var progs = station.getElementsByTagName("prog");
            var nowTime = new Date();
            var nowHM = parseInt(nowTime.getHours() + ("0" + nowTime.getMinutes()).slice(-2));
            var j = 0;
            for(; j < progs.length; j++) {
                var prog = progs[j];
                var _ftl = prog.attributes["ftl"].textContent;
                var _tol = prog.attributes["tol"].textContent;
                if(nowHM >= parseFloat(_ftl) && nowHM <= parseFloat(_tol)) {
                    break;
                }
            }
            var prog = progs[j];
            prog_title = prog.getElementsByTagName("title")[0].textContent;
            try {
                prog_pfm = prog.getElementsByTagName("pfm")[0].textContent;
            } catch(e) {
                prog_pfm = "?";
            }
            try {
                prog_desc = prog.getElementsByTagName("desc")[0].textContent
                    .replace(/<a /g, "<a target=\"_blank\" ");
            } catch(e) {
                prog_desc = "";
            }
            try {
                prog_desc += "<br />" + prog.getElementsByTagName("info")[0].textContent
                    .replace(/<a /g, "<a target=\"_blank\" ");
            } catch(e) {}
            try {
                var url = prog.getElementsByTagName("url")[0].textContent;
                if(url != "") {
                    prog_url = url;
                }
            } catch(e) {
                prog_url = "";
            }
            prog_ftl = new Array(_ftl.slice(0,2), _ftl.slice(2,4)).join(":");
            prog_tol = new Array(_tol.slice(0,2), _tol.slice(2,4)).join(":");
            break;
        }
    }
    var res = {"station_name":station_name, "title":prog_title, "pfm":prog_pfm,
               "desc": prog_desc, "url": prog_url, "ftl":prog_ftl, "tol":prog_tol};
    return res;
}

function getRadiruTimetableNow() {
    var channel = getChannel();
    var xhr = new XMLHttpRequest();
    xhr.open("GET", "http://cgi4.nhk.or.jp/tvnavi/api/noa-nr.cgi?mode=jsonp", false);
    xhr.send(null);
    var info = xhr.responseText;
    info = info.replace("nowonair(", "").replace(");", "");
    var info_json = JSON.parse(info);
    var stations = info_json["items"];
    var station_name = "";
    var prog_title = "";
    var prog_pfm = "";
    var prog_desc = "";
    var prog_url = "";
    var prog_ftl = "";
    var prog_tol = "";
    for(var i = 0; i < stations.length; i++) {
        var station_id = stations[i]["ch"].replace("net", "");
        if(channel == station_id) {
            var station = stations[i];
            station_name = (station_id == "r1")? "NHK ラジオ第1":
                (station_id == "r2")? "NHK ラジオ第2":
                (station_id == "fm")? "NHK FM":  "NHK";
            var prog = station;
            prog_title = prog["title"];
            try {
                prog_pfm = prog["subtitle"];
            } catch(e) {
                prog_pfm = "?";
            }
            try {
                prog_desc = prog["free"].replace(/<a /g, "<a target=\"_blank\" ");
            } catch(e) {
                prog_desc = "";
            }
            try {
                var url = prog["link"];
                if(url != "") {
                    prog_url = url;
                }
            } catch(e) {
                prog_url = "";
            }
            var _ftl = prog["starttime"];
            var _tol = prog["endtime"];
            prog_ftl = new Array(_ftl.slice(11,13), _ftl.slice(14,16)).join(":");
            prog_tol = new Array(_tol.slice(11,13), _tol.slice(14,16)).join(":");
            break;
        }
    }
    var res = {"station_name":station_name, "title":prog_title, "pfm":prog_pfm,
               "desc": prog_desc, "url": prog_url, "ftl":prog_ftl, "tol":prog_tol};
    return res;
}

function getDesktopnotificationTime() {
    var displaytime_dn = restore_options("radiko_dn_time");
    if(!displaytime_dn) {
        return 3;
    } else {
        return displaytime_dn;
    }
}

function setDesktopnotifications() {
    if(window.webkitNotifications.checkPermission() == 0) {
        showDesktopnotifications();
    }
}

var stID;  // for setTimeout()
function showDesktopnotifications() {
    if(window.webkitNotifications.checkPermission() != 0) {
        // alert("radiko playerオプション設定にて、\nDesktop Notificationsを許可してください。");
        return false;
    }
    else { // window.webkitNotifications.checkPermission() == 0
        var channel = getChannel();
        var prog_info = "";
        if(channel == "r1" || channel == "r2" || channel == "fm") {
            prog_info = getRadiruTimetableNow();
        } else {
            prog_info = getRadikoTimetableNow();
        }

        /*
         var dn = window.webkitNotifications.createNotification(
         chrome.extension.getURL("ra128.png"), "Now on air:",
         prog_info.ftl + " ~ " + prog_info.tol + " \n \"" +
         prog_info.title + "\"" + " by " + prog_info.pfm);
         */
        var dn = window.webkitNotifications.createHTMLNotification(
            chrome.extension.getURL("desktopnotification.html"));
        dn.show();
        setTimeout(
            function() { dn.cancel(); },
            getDesktopnotificationTime() * 1000);
        if(stID) { clearTimeout(stID); }
        if(prog_info.tol.slice(0,2) >= 24) {
            prog_info.tol = prog_info.tol.slice(0,2) - 24 + ":" + prog_info.tol.slice(3,5);
            if(prog_info.tol.length < 5) { prog_info.tol = "0" + prog_info.tol; }
        }
        var now = new Date();
        var diffmin = (prog_info.tol.slice(0,2)*60 + prog_info.tol.slice(3,5)*1) -
            (now.getHours()*60 + now.getMinutes());
        if(diffmin < 0) { diffmin += 24 * 60; }
        stID = setTimeout(
            function() { showDesktopnotifications(); },
            (diffmin * 60 - now.getSeconds()) * 1000 + 10000);
    }
}

function showShow(elem, prefunc, postfunc) {
    prefunc();
    var channel = getChannel();
    var prog_info = "";
    if(channel == "r1" || channel == "r2" || channel == "fm") {
        prog_info = getRadiruTimetableNow();
    } else {
        prog_info = getRadikoTimetableNow();
    }
    var show_elem = document.createElement("dl");
    show_elem.setAttribute("id", "show");
    var time_t_elem = document.createElement("dt");
    time_t_elem.setAttribute("class", "show_t");
    time_t_elem.innerHTML = "放送時間";
    var time_elem = document.createElement("dd");
    time_elem.setAttribute("class", "show_time");
    time_elem.innerHTML = prog_info.ftl + " &#12316; " + prog_info.tol;
    show_elem.appendChild(time_t_elem);
    show_elem.appendChild(time_elem);
    var title_t_elem = document.createElement("dt");
    title_t_elem.setAttribute("class", "show_t");
    title_t_elem.innerHTML = "番組名";
    var title_elem = document.createElement("dd");
    title_elem.setAttribute("class", "show_title");
    title_elem.innerHTML = prog_info.title;
    show_elem.appendChild(title_t_elem);
    show_elem.appendChild(title_elem);
    var pfm_t_elem = document.createElement("dt");
    pfm_t_elem.setAttribute("class", "show_t");
    pfm_t_elem.innerHTML = "パーソナリティ";
    var pfm_elem = document.createElement("dd");
    pfm_elem.setAttribute("class", "show_pfm");
    pfm_elem.innerHTML = prog_info.pfm;
    show_elem.appendChild(pfm_t_elem);
    show_elem.appendChild(pfm_elem);
    var channel = getChannel();
    if(channel == "INT" || channel == "FMT" || channel == "FMJ" ||
       channel == "CCL" ||  channel == "802" ||  channel == "FMO") {
        var nowonair_t_elem = document.createElement("dt");
        nowonair_t_elem.setAttribute("class", "show_t");
        nowonair_t_elem.innerHTML = "Now on air";
        var nowonair_elem = document.createElement("dd");
        getNowonair(channel, nowonair_elem);
        nowonair_elem.setAttribute("class", "show_nowonair");
        show_elem.appendChild(nowonair_t_elem);
        show_elem.appendChild(nowonair_elem);
    }
    if(prog_info.url != "") {
        var url_t_elem = document.createElement("dt");
        url_t_elem.setAttribute("class", "show_t");
        url_t_elem.innerHTML = "Webサイト";
        var url_elem = document.createElement("dd");
        url_elem.setAttribute("class", "show_url");
        url_elem.innerHTML = "<a href=\"" + prog_info.url +
            "\" title=\"" + prog_info.url + "\" target=\"_blank\">"+ prog_info.url +"</a>";
        show_elem.appendChild(url_t_elem);
        show_elem.appendChild(url_elem);
    }
    if(prog_info.desc != "") {
        var desc_t_elem = document.createElement("dt");
        desc_t_elem.setAttribute("class", "show_t");
        desc_t_elem.innerHTML = "概要";
        var desc_elem = document.createElement("dd");
        desc_elem.setAttribute("class", "show_desc");
        desc_elem.innerHTML = prog_info.desc;
        show_elem.appendChild(desc_t_elem);
        show_elem.appendChild(desc_elem);
    }
    elem.innerHTML = "<hr />" + show_elem.outerHTML;
    postfunc();
}

chrome.extension.onRequest.addListener(
    function(request, sender, sendResponse) {
        if(request.type == "desktopnotification") {
            var prog_info;
            var channel = getChannel();
            if(channel == "r1" || channel == "r2" || channel == "fm") {
                prog_info = getRadiruTimetableNow();
            } else {
                prog_info = getRadikoTimetableNow();
            }
            sendResponse(prog_info);
        }
    });

