function showNowloading() {
    var nl = document.getElementById("nowloading");
    var nl_img = document.createElement("img");
    nl_img.src = "nowloading.gif";
    nl.appendChild(nl_img);
}
function removeNowloading() {
    var nl = document.getElementById("nowloading");
    nl.innerHTML = "";
}
function showNowonair(station_id) {
    var bg = chrome.extension.getBackgroundPage();
    bg.getNowonair(station_id, document.getElementById("nowonair_"+station_id));
}

function showShow() {
    var bg = chrome.extension.getBackgroundPage();
    document.getElementById("body").style.width = "400px";
    document.getElementById("body").style["overflow-y"] = "auto";
    bg.showShow(document.getElementById("timetable"), showNowloading, removeNowloading);
}
function showTimetable() {
    var bg = chrome.extension.getBackgroundPage();
    document.getElementById("body").style.width = "500px";
    bg.showTimetable(document.getElementById("timetable"),
                     showNowloading, removeNowloading);
}
function setPlayer() {
    var chs = document.getElementById('channel');
    if(chs.value) {
        var channel = chs[chs.selectedIndex].value;
        var bg = chrome.extension.getBackgroundPage();
        setOfficialLink(channel);
        // radiru
        if(channel == "r1" || channel == "r2" || channel == "fm") {
            document.getElementById("show_player").href =
                "http://www3.nhk.or.jp/netradio/player/index.html?"+channel;
        } else {
            document.getElementById("show_player").href =
                "http://radiko.jp/#"+channel;
        }
        if(!bg.isPlaying()) {
            bg.save_options({"radiko_channel": channel});
        }
    }
}
function setOfficialLink(channel) {
    var official_link = document.getElementById("official_link");
    var official_tt = document.getElementById("official_tt");
    if(channel == "r1" || channel == "r2" || channel == "fm") {
        official_link.href = "http://www3.nhk.or.jp/netradio/";
        official_link.innerHTML = '<img src="radiru.png" title="らじる★らじる" alt="radiru" />';
        official_tt.href = "http://www3.nhk.or.jp/netradio/hensei.html";
    } else {
        official_link.href = "http://radiko.jp/";
        official_link.innerHTML = '<img src="radiko.png" title="radiko.jp" alt="radiko.jp" />';
        official_tt.href = "http://radiko.jp/timetable/";
    }
}
function play() {
    var bg = chrome.extension.getBackgroundPage();
    var select = document.getElementById("channel");
    var channel = select[select.selectedIndex].value;
    try {
        var trs = document.getElementsByClassName("station_name");
        for(var i = 0; i < trs.length; i++) {
            trs[i].style.backgroundColor = "#FFFF99";
        }
        document.getElementById("station_"+channel).style.backgroundColor = "#FFCC00";
    } catch(e) {}
    setPlayer(channel);
    bg.setChannel(channel);
}
function stop() {
    var bg = chrome.extension.getBackgroundPage();
    bg.stopPlayer();
}
function detach() {
    var p = window.clientInformation.platform
    var height = 435;
    if(p[0] == "M") {  // "MacIntel"
        height = 435;
    } else if(p[0] == "L") {  // "Linux *"
        height = 400;
    } else if(p[0] == "W") {  // "Win*"
        height = 300;
    }
    window.open(
        chrome.extension.getURL("popup.html?detached"),
        "radiko player",
        "left=100,top=78," +
        "width=415,height=" + height + "," +
        "location=no,menubar=no,resizable=yes,status=no,titlebar=yes,toolbar=no"
    );
    window.close();
}
function init() {
    var bg = chrome.extension.getBackgroundPage();
    var p = window.clientInformation.platform
    if(p[0] == "M") {  // "MacIntel"
        document.getElementById("body").style.width="280px";
    } else if(p[0] == "L") {  // "Linux *"
        document.getElementById("body").style.width="290px";
    } else if(p[0] == "W") {  // "Win*"
        document.getElementById("body").style.width="295px";
    }
    var channel_elem = document.getElementById("channel");
    bg.getStations(channel_elem);
    var channel = bg.getChannel();
    setPlayer(channel);
    setOfficialLink(channel);
    if(bg.isShowtimetable()) {
        showTimetable();
    }
}
function checkKey(event) {
    if(event.keyCode == 40) { // down
        showTimetable();
    }
}
function showHidingprog(station_id) {
    document.getElementById(station_id + "_1").style.display = "table-row";
    document.getElementById("station_"+station_id).style.fontSize = "12px";
}
function hideShowingprog(station_id) {
    document.getElementById(station_id + "_1").style.display = "none";
    document.getElementById("station_"+station_id).style.fontSize = "11px";
}


document.addEventListener('DOMContentLoaded', function () {
    init();
    document.getElementById('body').addEventListener('keydown', checkKey, false);
    document.getElementById('channel').addEventListener('change', setPlayer, false);
    document.getElementById('showshow_elem').addEventListener('click', showShow);
    document.getElementById('play_elem').addEventListener('click', play);
    document.getElementById('stop_elem').addEventListener('click', stop);
    document.getElementById('player_tt').addEventListener('click', showTimetable);
    document.getElementById('show_player').addEventListener('click', stop);
});
