//@ sourceMappingURL=day_history.map
// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Chrome.DayHistory = (function(_super) {

    __extends(DayHistory, _super);

    function DayHistory(date) {
      date.setHours(0, 0, 0, 0);
      this.startTime = date.getTime();
      date.setHours(23, 59, 59, 999);
      this.endTime = date.getTime();
      this.historyQuery = new BH.Lib.HistoryQuery(this.chromeAPI);
      this.worker = BH.Modules.Worker.worker;
    }

    DayHistory.prototype.fetch = function() {
      var options,
        _this = this;
      options = {
        startTime: this.startTime,
        endTime: this.endTime,
        text: '',
        maxResults: 5000
      };
      return chrome.history.search(options, function(results) {
        options = {
          options: options,
          results: results
        };
        return _this.worker('rangeSanitizer', options, function(sanitizedResults) {
          options.results = sanitizedResults;
          return _this.worker('timeGrouper', options, function(history) {
            if (settings.get('domainGrouping')) {
              options = {
                intervals: history
              };
              return _this.worker('domainGrouper', options, function(history) {
                return _this.trigger('query:complete', [history]);
              });
            } else {
              return _this.trigger('query:complete', [history]);
            }
          });
        });
      });
    };

    DayHistory.prototype.destroy = function() {
      var options,
        _this = this;
      options = {
        startTime: this.startTime,
        endTime: this.endTime
      };
      return chrome.history.deleteRange(options, function() {
        return _this.trigger('destroy:complete');
      });
    };

    return DayHistory;

  })(EventEmitter);

}).call(this);
