// Generated by CoffeeScript 1.6.1
(function() {

  BH.Chrome.PageContextMenu = (function() {

    function PageContextMenu(options) {
      if (options == null) {
        options = {};
      }
      if (options.chrome == null) {
        throw "Chrome API not set";
      }
      if (options.tracker == null) {
        throw "Tracker not set";
      }
      this.chromeAPI = options.chrome;
      this.tracker = options.tracker;
      this.id = 'better_history_page_context_menu';
    }

    PageContextMenu.prototype.create = function() {
      var _this = this;
      this.menu = this.chromeAPI.contextMenus.create({
        title: this.chromeAPI.i18n.getMessage('visits_to_domain', ['domain']),
        contexts: ['page'],
        id: this.id
      });
      return this.chromeAPI.contextMenus.onClicked.addListener(function(data) {
        return _this.onClick(data);
      });
    };

    PageContextMenu.prototype.onClick = function(data) {
      var domain, url;
      if (data.menuItemId === this.id) {
        url = (domain = this.getDomain(data.pageUrl)) ? "chrome://history/#search/" + domain : "chrome://history/#search";
        this.tracker.contextMenuClick();
        return this.chromeAPI.tabs.create({
          url: url
        });
      }
    };

    PageContextMenu.prototype.updateTitleDomain = function(tab) {
      var domain;
      if (tab == null) {
        tab = {};
      }
      if (domain = this.getDomain(tab.url)) {
        return this.chromeAPI.contextMenus.update(this.menu, {
          title: this.chromeAPI.i18n.getMessage('visits_to_domain', [domain])
        });
      }
    };

    PageContextMenu.prototype.listenToTabs = function() {
      var _ref, _ref1,
        _this = this;
      if ((_ref = this.chromeAPI.tabs) != null) {
        if ((_ref1 = _ref.onActivated) != null) {
          _ref1.addListener(function(tabInfo) {
            if (_this.menu) {
              return _this.onTabSelectionChanged(tabInfo.tabId);
            }
          });
        }
      }
      return this.chromeAPI.tabs.onUpdated.addListener(function(tabId, changedInfo, tab) {
        if (_this.menu) {
          return _this.onTabUpdated(tab);
        }
      });
    };

    PageContextMenu.prototype.onTabSelectionChanged = function(tabId) {
      var _this = this;
      return this.chromeAPI.tabs.get(tabId, function(tab) {
        return _this.updateTitleDomain(tab);
      });
    };

    PageContextMenu.prototype.onTabUpdated = function(tab) {
      if (tab != null ? tab.selected : void 0) {
        return this.updateTitleDomain(tab);
      }
    };

    PageContextMenu.prototype.remove = function() {
      this.chromeAPI.contextMenus.remove(this.menu);
      return delete this.menu;
    };

    PageContextMenu.prototype.getDomain = function(url) {
      var match;
      if (url == null) {
        url = '';
      }
      match = url.match(/\w+:\/\/(.*?)\//);
      if (match != null) {
        return match[1].replace('www.', '');
      } else {
        return false;
      }
    };

    return PageContextMenu;

  })();

}).call(this);
