// Generated by CoffeeScript 1.6.1
(function() {

  BH.Chrome.SelectionContextMenu = (function() {

    function SelectionContextMenu(options) {
      if (options == null) {
        options = {};
      }
      if (options.chrome == null) {
        throw "Chrome API not set";
      }
      if (options.tracker == null) {
        throw "Tracker not set";
      }
      this.chromeAPI = options.chrome;
      this.tracker = options.tracker;
      this.id = 'better_history_selection_context_menu';
    }

    SelectionContextMenu.prototype.create = function() {
      var _ref,
        _this = this;
      if (((_ref = this.chromeAPI.contextMenus) != null ? _ref.create : void 0) != null) {
        this.menu = this.chromeAPI.contextMenus.create({
          title: chrome.i18n.getMessage('search_in_history'),
          contexts: ['selection'],
          id: this.id
        });
        return this.chromeAPI.contextMenus.onClicked.addListener(function(data) {
          return _this.onClick(data);
        });
      }
    };

    SelectionContextMenu.prototype.onClick = function(data) {
      if (data.menuItemId === this.id) {
        this.tracker.selectionContextMenuClick();
        return this.chromeAPI.tabs.create({
          url: "chrome://history/#search/" + data.selectionText
        });
      }
    };

    SelectionContextMenu.prototype.remove = function() {
      this.chromeAPI.contextMenus.remove(this.menu);
      return delete this.menu;
    };

    return SelectionContextMenu;

  })();

}).call(this);
