// Generated by CoffeeScript 1.6.1
(function() {
  var SitesHasher;

  SitesHasher = (function() {

    function SitesHasher(shaFunction, scope) {
      this.shaFunction = shaFunction;
      this.scope = scope != null ? scope : null;
      if (this.shaFunction == null) {
        throw "Need a sha function";
      }
    }

    SitesHasher.prototype.generate = function(sites) {
      var compiledString, data, site, stringifiedData, _i, _len;
      data = [];
      for (_i = 0, _len = sites.length; _i < _len; _i++) {
        site = sites[_i];
        if (site.tags.length > 0) {
          compiledString = "" + site.url + ": " + (site.tags.sort().join(', '));
          data.push(compiledString);
        }
      }
      stringifiedData = data.sort().join('|');
      if (data.length === 0) {
        return "";
      } else {
        return this.shaFunction.apply(this.scope, [stringifiedData]);
      }
    };

    return SitesHasher;

  })();

  if (typeof exports !== 'undefined') {
    module.exports = SitesHasher;
  } else {
    BH.Lib.SitesHasher = SitesHasher;
  }

}).call(this);
