//@ sourceMappingURL=sync_store.map
// Generated by CoffeeScript 1.6.1
(function() {

  BH.Lib.SyncStore = (function() {

    function SyncStore(options) {
      if (options == null) {
        options = {};
      }
      if (options.chrome == null) {
        throw "Chrome API not set";
      }
      if (options.tracker == null) {
        throw "Tracker not set";
      }
      this.chromeAPI = options.chrome;
      this.tracker = options.tracker;
    }

    SyncStore.prototype.set = function(object, callback) {
      var _this = this;
      if (callback == null) {
        callback = function() {};
      }
      return this.chromeAPI.storage.sync.set(object, function(data) {
        return _this.wrappedCallback('Set', data, callback);
      });
    };

    SyncStore.prototype.remove = function(key, callback) {
      var _this = this;
      if (callback == null) {
        callback = function() {};
      }
      return this.chromeAPI.storage.sync.remove(key, function(data) {
        return _this.wrappedCallback('Remove', data, callback);
      });
    };

    SyncStore.prototype.get = function(key, callback) {
      var _this = this;
      return this.chromeAPI.storage.sync.get(key, function(data) {
        return _this.wrappedCallback('Get', data, callback);
      });
    };

    SyncStore.prototype.wrappedCallback = function(operation, data, callback) {
      var message, _ref;
      if (data == null) {
        data = {};
      }
      if (this.chromeAPI.runtime.lastError != null) {
        message = (_ref = this.chromeAPI.runtime.lastError) != null ? _ref.message : void 0;
        this.tracker.syncStorageError(operation, message);
      } else {
        if (operation !== 'Get') {
          this.tracker.syncStorageAccess(operation);
        }
      }
      return callback(data);
    };

    return SyncStore;

  })();

}).call(this);
