//@ sourceMappingURL=week_history.map
// Generated by CoffeeScript 1.6.1
(function() {

  BH.Lib.WeekHistory = (function() {

    function WeekHistory(date) {
      date.setHours(0, 0, 0, 0);
      this.startTime = date.getTime();
      date = new Date(date.getTime() + (6 * 86400000));
      date.setHours(23, 59, 59, 999);
      this.endTime = date.getTime();
      this.worker = BH.Modules.Worker.worker;
      this.history = new BH.Chrome.History();
    }

    WeekHistory.prototype.fetch = function(callback) {
      var options,
        _this = this;
      if (callback == null) {
        callback = function() {};
      }
      options = {
        startTime: this.startTime,
        endTime: this.endTime,
        text: '',
        maxResults: 5000
      };
      return this.history.query(options, function(results) {
        options = {
          options: options,
          results: results
        };
        return _this.worker('rangeSanitizer', options, function(sanitizedResults) {
          return _this.worker('dayGrouper', {
            visits: sanitizedResults
          }, function(history) {
            return callback(history);
          });
        });
      });
    };

    WeekHistory.prototype.destroy = function(callback) {
      var options,
        _this = this;
      if (callback == null) {
        callback = function() {};
      }
      options = {
        startTime: this.startTime,
        endTime: this.endTime
      };
      return this.history.deleteRange(options, function() {
        return callback();
      });
    };

    return WeekHistory;

  })();

}).call(this);
