// Generated by CoffeeScript 1.6.1
(function() {
  var delay,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Router = (function(_super) {

    __extends(Router, _super);

    function Router() {
      return Router.__super__.constructor.apply(this, arguments);
    }

    Router.prototype.routes = {
      '': 'visits',
      'tags': 'tags',
      'tags/:id': 'tag',
      'devices': 'devices',
      'settings': 'settings',
      'search/*query(/p:page)': 'search',
      'search': 'search',
      'visits(/:date)': 'visits',
      'trails/new': 'newTrail',
      'trails/:name': 'trail'
    };

    Router.prototype.initialize = function(options) {
      var settings, tracker;
      settings = options.settings;
      tracker = options.tracker;
      this.cache = new BH.Views.Cache({
        settings: settings
      });
      this.trails = new Backbone.Collection();
      this.app = new BH.Views.AppView({
        el: $('.app'),
        settings: settings,
        trails: this.trails
      });
      this.app.render();
      return this.on('route', function() {
        var url;
        url = Backbone.history.getFragment();
        return window.analyticsTracker.pageView(url);
      });
    };

    Router.prototype.tags = function() {
      var transitioningView, view, _ref;
      _ref = this.cache.view('tags'), view = _ref[0], transitioningView = _ref[1];
      return delay(transitioningView, function() {
        return view.collection.fetch();
      });
    };

    Router.prototype.devices = function() {
      var transitioningView, view, _ref;
      _ref = this.cache.view('devices'), view = _ref[0], transitioningView = _ref[1];
      return delay(transitioningView, function() {
        return new Historian.Devices().fetch(function(devices) {
          return view.collection.reset(devices);
        });
      });
    };

    Router.prototype.tag = function(id) {
      var transitioningView, view, _ref;
      _ref = this.cache.view('tag', [id]), view = _ref[0], transitioningView = _ref[1];
      return delay(transitioningView, function() {
        return view.model.fetch();
      });
    };

    Router.prototype.newTrail = function() {
      var view,
        _this = this;
      view = this.cache.view('newTrail');
      return view.on('build_trail', function(model) {
        return _this.trails.add(model);
      });
    };

    Router.prototype.trail = function(name) {
      var view;
      return view = this.cache.view('trail');
    };

    Router.prototype.visits = function(date) {
      var transitioningView, view, _ref;
      if (date == null) {
        date = 'today';
      }
      date = (function() {
        switch (date) {
          case 'today':
            return moment();
          case 'yesterday':
            return moment().subtract('days', 1);
          default:
            return moment(new Date(date));
        }
      })();
      date = date.startOf('day').toDate();
      _ref = this.cache.view('visits', [date]), view = _ref[0], transitioningView = _ref[1];
      return delay(transitioningView, function() {
        return new Historian.Day(date).fetch(function(history) {
          return view.collection.reset(history);
        });
      });
    };

    Router.prototype.settings = function() {
      var view;
      return view = this.cache.view('settings');
    };

    Router.prototype.search = function(query, page) {
      var view;
      $('.menu > *').removeClass('selected');
      view = this.cache.view('search')[0];
      if (page != null) {
        view.page.set({
          page: parseInt(page, 10)
        }, {
          silent: true
        });
      }
      view.model.set({
        query: decodeURIComponent(query)
      });
      return delay(true, function() {
        if ((query != null) && query !== '') {
          view.historian = new Historian.Search(query);
          return view.historian.fetch({}, function(history, cacheDatetime) {
            if (cacheDatetime == null) {
              cacheDatetime = null;
            }
            view.collection.reset(history);
            if (cacheDatetime != null) {
              return view.model.set({
                cacheDatetime: cacheDatetime
              });
            } else {
              return view.model.unset('cacheDatetime');
            }
          });
        }
      });
    };

    return Router;

  })(Backbone.Router);

  delay = function(shouldDelay, callback) {
    if (shouldDelay) {
      return setTimeout((function() {
        return callback();
      }), 250);
    } else {
      return callback();
    }
  };

}).call(this);
