// Generated by CoffeeScript 1.6.1
(function() {

  BH.Trackers.AnalyticsTracker = (function() {

    function AnalyticsTracker() {
      if (typeof _gaq === "undefined" || _gaq === null) {
        throw "Analytics not set";
      }
    }

    AnalyticsTracker.prototype.trackEvent = function(params) {
      params.unshift('_trackEvent');
      return this.track(params);
    };

    AnalyticsTracker.prototype.pageView = function(url) {
      if (url.match(/search/)) {
        url = 'search';
      }
      return this.track(['_trackPageview', "/" + url]);
    };

    AnalyticsTracker.prototype.track = function(params) {
      return _gaq.push(params);
    };

    AnalyticsTracker.prototype.historyOpen = function() {
      return this.trackEvent(['History', 'Open']);
    };

    AnalyticsTracker.prototype.weekView = function(date, distanceFromCurrentWeek) {
      return this.trackEvent(['Weeks', 'Click', date, distanceFromCurrentWeek]);
    };

    AnalyticsTracker.prototype.todayView = function() {
      return this.trackEvent(['Today', 'Click']);
    };

    AnalyticsTracker.prototype.calendarView = function() {
      return this.trackEvent(['Calendar', 'Click']);
    };

    AnalyticsTracker.prototype.visitDeletion = function() {
      return this.trackEvent(['Visit', 'Delete']);
    };

    AnalyticsTracker.prototype.hourDeletion = function() {
      return this.trackEvent(['Day Hour', 'Delete']);
    };

    AnalyticsTracker.prototype.searchResultDeletion = function() {
      return this.trackEvent(['Searched Visit', 'Delete']);
    };

    AnalyticsTracker.prototype.searchResultsDeletion = function() {
      return this.trackEvent(['Search results', 'Delete']);
    };

    AnalyticsTracker.prototype.paginationClick = function() {
      return this.trackEvent(['Pagination', 'Click']);
    };

    AnalyticsTracker.prototype.deviceClick = function() {
      return this.trackEvent(['Device', 'Click']);
    };

    AnalyticsTracker.prototype.omniboxSearch = function() {
      return this.trackEvent(['Omnibox', 'Search']);
    };

    AnalyticsTracker.prototype.contextMenuClick = function() {
      return this.trackEvent(['Context menu', 'Click']);
    };

    AnalyticsTracker.prototype.selectionContextMenuClick = function() {
      return this.trackEvent(['Selection context menu', 'Click']);
    };

    AnalyticsTracker.prototype.syncStorageError = function(operation, msg) {
      return this.trackEvent(['Storage Error', operation, 'Sync', msg]);
    };

    AnalyticsTracker.prototype.syncStorageAccess = function(operation) {
      return this.trackEvent(['Storage Access', operation, 'Sync']);
    };

    AnalyticsTracker.prototype.localStorageError = function(operation, msg) {
      return this.trackEvent(['Storage Error', operation, 'Local', msg]);
    };

    AnalyticsTracker.prototype.mailingListPrompt = function() {
      return this.trackEvent(['Mailing List Prompt', 'Seen']);
    };

    AnalyticsTracker.prototype.hourClick = function(hour) {
      return this.trackEvent(['Visits', 'Hour Click', hour]);
    };

    AnalyticsTracker.prototype.popupVisible = function() {
      return this.trackEvent(['Popup', 'Seen']);
    };

    AnalyticsTracker.prototype.exploreTagsPopupClick = function() {
      return this.trackEvent(['Popup', 'Explore Tags Click']);
    };

    AnalyticsTracker.prototype.searchByDomainPopupClick = function() {
      return this.trackEvent(['Popup', 'Search by Domain Click']);
    };

    AnalyticsTracker.prototype.tagDetailsPopupClick = function() {
      return this.trackEvent(['Popup', 'Tag Details Click']);
    };

    AnalyticsTracker.prototype.viewAllHistoryPopupClick = function() {
      return this.trackEvent(['Popup', 'View all History Click']);
    };

    AnalyticsTracker.prototype.howToTagClick = function() {
      return this.trackEvent(['Tags', 'How to Tag Click']);
    };

    AnalyticsTracker.prototype.deleteAllTagsClick = function() {
      return this.trackEvent(['Tags', 'Delete all Click']);
    };

    AnalyticsTracker.prototype.siteTagDrag = function() {
      return this.trackEvent(['Tag', 'Site Drag']);
    };

    AnalyticsTracker.prototype.siteTagDrop = function() {
      return this.trackEvent(['Tag', 'Site Drop']);
    };

    AnalyticsTracker.prototype.renameTagClick = function() {
      return this.trackEvent(['Tag', 'Rename Click']);
    };

    AnalyticsTracker.prototype.deleteTagClick = function() {
      return this.trackEvent(['Tag', 'Delete Tag Click']);
    };

    AnalyticsTracker.prototype.tagAdded = function() {
      return this.trackEvent(['Tag', 'Added']);
    };

    AnalyticsTracker.prototype.tagRemoved = function() {
      return this.trackEvent(['Tag', 'Removed']);
    };

    AnalyticsTracker.prototype.tagRenamed = function() {
      return this.trackEvent(['Tag', 'Renamed']);
    };

    AnalyticsTracker.prototype.siteTagged = function() {
      return this.trackEvent(['Site', 'Tagged']);
    };

    AnalyticsTracker.prototype.siteUntagged = function() {
      return this.trackEvent(['Site', 'Untagged']);
    };

    AnalyticsTracker.prototype.shareClicked = function() {
      return this.trackEvent(['Tag', 'Shared']);
    };

    AnalyticsTracker.prototype.getStartedSyncingModalSeen = function() {
      return this.trackEvent(['Get Started Modal', 'Seen']);
    };

    AnalyticsTracker.prototype.getStartedSyncingContinueClicked = function() {
      return this.trackEvent(['Get Started Modal', 'Continue Click']);
    };

    AnalyticsTracker.prototype.getStartedSyncingCancelClicked = function() {
      return this.trackEvent(['Get Started Modal', 'Cancel Click']);
    };

    AnalyticsTracker.prototype.syncPurchaseSuccess = function() {
      return this.trackEvent(['Sync', 'Purchased', 'Success']);
    };

    AnalyticsTracker.prototype.syncPurchaseFailure = function() {
      return this.trackEvent(['Sync', 'Purchased', 'Failure']);
    };

    AnalyticsTracker.prototype.syncDecisionModalSeen = function() {
      return this.trackEvent(['Sync Decision Modal', 'Seen']);
    };

    AnalyticsTracker.prototype.syncAutomaticModalSeen = function() {
      return this.trackEvent(['Sync Automatic Modal', 'Seen']);
    };

    AnalyticsTracker.prototype.userLoggedIn = function() {
      return this.trackEvent(['User', 'Log In']);
    };

    AnalyticsTracker.prototype.userLoggedOut = function() {
      return this.trackEvent(['User', 'Log Out']);
    };

    AnalyticsTracker.prototype.userCreationFailure = function() {
      return this.trackEvent(['User', 'Creation', 'Failure']);
    };

    AnalyticsTracker.prototype.userCreationSuccess = function() {
      return this.trackEvent(['User', 'Creation', 'Success']);
    };

    AnalyticsTracker.prototype.userOAuthFailure = function() {
      return this.trackEvent(['User', 'OAuth', 'Failure']);
    };

    AnalyticsTracker.prototype.userOAuthSuccess = function() {
      return this.trackEvent(['User', 'OAuth', 'Success']);
    };

    AnalyticsTracker.prototype.ensureDatetimeOnTaggedSitesMigration = function() {
      return this.trackEvent(['Migration', 'ensure_datetime_on_tagged_sites']);
    };

    return AnalyticsTracker;

  })();

}).call(this);
