// Generated by CoffeeScript 1.6.1
(function() {

  BH.Views.Cache = (function() {

    function Cache(options) {
      this.options = options;
      this.settings = this.options.settings;
      this.state = this.options.state;
      this.expire();
    }

    Cache.prototype.expire = function() {
      return this.cache = {
        tags: {},
        trails: {}
      };
    };

    Cache.prototype.view = function(name, args) {
      var isDifferentView, methodName, view;
      methodName = (function() {
        switch (name) {
          case 'tags':
            return 'tagsView';
          case 'devices':
            return 'devicesView';
          case 'visits':
            return 'visitsView';
          case 'trail':
            return 'trailView';
          case 'newTrail':
            return 'newTrailView';
          case 'tag':
            return 'tagView';
          case 'search':
            return 'searchView';
          case 'settings':
            return 'settingsView';
        }
      })();
      view = this[methodName].apply(this, args);
      isDifferentView = name !== this.lastRequest;
      if (isDifferentView) {
        view.select();
      }
      this.lastRequest = name;
      return [view, isDifferentView];
    };

    Cache.prototype.tagsView = function() {
      var tags;
      if (!this.cache.allTags) {
        tags = new BH.Collections.Tags([]);
        this.cache.allTags = new BH.Views.TagsView({
          collection: tags,
          state: this.state
        });
        this.insert(this.cache.allTags.render().el);
      }
      return this.cache.allTags;
    };

    Cache.prototype.devicesView = function() {
      var devices;
      if (!this.cache.devices) {
        devices = new BH.Collections.Devices();
        this.cache.devices = new BH.Views.DevicesView({
          collection: devices,
          state: this.state
        });
        this.insert(this.cache.devices.render().el);
      }
      return this.cache.devices;
    };

    Cache.prototype.visitsView = function(date) {
      if (!this.cache.visits) {
        this.cache.visits = new BH.Views.VisitsView({
          collection: new Backbone.Collection(),
          model: new Backbone.Model({
            date: date
          })
        });
        this.insert(this.cache.visits.render().el);
      }
      this.cache.visits.model.set({
        date: date
      });
      return this.cache.visits;
    };

    Cache.prototype.trailView = function(name) {
      if (!this.cache.trails[name]) {
        this.cache.trails[name] = new BH.Views.TrailView({
          name: name
        });
        this.insert(this.cache.trails[name].render().el);
      }
      return this.cache.trails[name];
    };

    Cache.prototype.newTrailView = function() {
      if (!this.cache.newTrail) {
        this.cache.newTrail = new BH.Views.NewTrailView();
        this.insert(this.cache.newTrail.render().el);
      }
      return this.cache.newTrail;
    };

    Cache.prototype.tagView = function(id) {
      var tag;
      if (!this.cache.tags[id]) {
        tag = new BH.Models.Tag({
          name: id
        });
        this.cache.tags[id] = new BH.Views.TagView({
          name: id,
          model: tag,
          state: this.state
        });
        this.insert(this.cache.tags[id].render().el);
      }
      return this.cache.tags[id];
    };

    Cache.prototype.searchView = function() {
      if (!this.cache.search) {
        this.cache.search = new BH.Views.SearchView({
          model: new Backbone.Model(),
          collection: new Backbone.Collection()
        });
        this.insert(this.cache.search.render().el);
      }
      return this.cache.search;
    };

    Cache.prototype.settingsView = function() {
      if (!this.cache.settings) {
        this.cache.settings = new BH.Views.SettingsView({
          model: this.settings,
          state: this.state
        });
        this.insert(this.cache.settings.render().el);
      }
      return this.cache.settings;
    };

    Cache.prototype.insert = function(html) {
      return $('.mainview').append(html);
    };

    return Cache;

  })();

}).call(this);
