// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.DevicesView = (function(_super) {

    __extends(DevicesView, _super);

    function DevicesView() {
      return DevicesView.__super__.constructor.apply(this, arguments);
    }

    DevicesView.include(BH.Modules.I18n);

    DevicesView.prototype.className = 'devices_view with_controls';

    DevicesView.prototype.template = BH.Templates['devices'];

    DevicesView.prototype.events = {
      'keyup .search': 'onSearchTyped',
      'blur .search': 'onSearchBlurred'
    };

    DevicesView.prototype.initialize = function() {
      this.chromeAPI = chrome;
      this.tracker = analyticsTracker;
      this.collection.on('reset', this.onCollectionReset, this);
      return this.model = new Backbone.Model();
    };

    DevicesView.prototype.pageTitle = function() {
      return this.t('devices_title');
    };

    DevicesView.prototype.render = function() {
      var devicesResultsView, html, properties;
      properties = _.extend(this.getI18nValues(), {
        devices: this.collection.toJSON()
      });
      html = Mustache.to_html(this.template, properties);
      this.$el.append(html);
      devicesResultsView = new BH.Views.DevicesResultsView({
        model: this.model,
        collection: new Backbone.Collection(),
        el: this.$('.content')
      });
      return this;
    };

    DevicesView.prototype.onCollectionReset = function() {
      var devicesListView;
      this.$('.devices_list_view').remove();
      devicesListView = new BH.Views.DevicesListView({
        collection: this.collection,
        model: this.model
      });
      this.$('header').append(devicesListView.render().el);
      return devicesListView.$('a').eq(0)[0].click();
    };

    DevicesView.prototype.getI18nValues = function() {
      var properties;
      properties = this.t(['devices_title', 'search_input_placeholder_text']);
      return properties;
    };

    return DevicesView;

  })(BH.Views.MainView);

}).call(this);
