// Generated by CoffeeScript 1.6.1
(function() {
  var highlightBackward, highlightForward,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.MonthView = (function(_super) {

    __extends(MonthView, _super);

    function MonthView() {
      return MonthView.__super__.constructor.apply(this, arguments);
    }

    MonthView.include(BH.Modules.I18n);

    MonthView.prototype.template = BH.Templates['month'];

    MonthView.prototype.events = {
      'click .selected': 'onWeekClicked',
      'mouseover td': 'onDayMouseOver',
      'mouseout td': 'onDayMouseOut',
      'click .previous_month': 'onPreviousMonthClick',
      'click .next_month': 'onNextMonthClick'
    };

    MonthView.prototype.render = function() {
      var html, presenter, properties;
      presenter = new BH.Presenters.CalendarPresenter(this.model.toJSON());
      properties = _.extend({}, this.getI18nValues(), presenter.calendar());
      html = Mustache.to_html(this.template, properties);
      this.$el.html(html);
      return this;
    };

    MonthView.prototype.onWeekClicked = function(ev) {
      var weekId;
      ev.preventDefault();
      weekId = this.$('.selected').first().data('week-id');
      return router.navigate("weeks/" + weekId, {
        trigger: true
      });
    };

    MonthView.prototype.onPreviousMonthClick = function(ev) {
      var date;
      ev.preventDefault();
      date = this.model.get('monthDate');
      date.setMonth(date.getMonth() - 1);
      this.model.set({
        monthDate: date
      });
      return this.render();
    };

    MonthView.prototype.onNextMonthClick = function(ev) {
      var date;
      ev.preventDefault();
      date = this.model.get('monthDate');
      date.setMonth(date.getMonth() + 1);
      this.model.set({
        monthDate: date
      });
      return this.render();
    };

    MonthView.prototype.onDayMouseOver = function(ev) {
      var $el, highlightedDays, startingWeekDay;
      this.$('.selected').removeClass('selected');
      startingWeekDay = settings.get('startingWeekDay').toLowerCase();
      $el = $(ev.currentTarget);
      $el.addClass('selected');
      highlightedDays = 1;
      if ($el.data('day') === '') {
        return;
      }
      if ($el.data('day').toLowerCase() === startingWeekDay) {
        return highlightForward($el, highlightedDays);
      } else {
        highlightedDays = highlightBackward(startingWeekDay, $el);
        return highlightForward($el, highlightedDays);
      }
    };

    MonthView.prototype.onDayMouseOut = function() {
      return this.$('.selected').removeClass('selected');
    };

    MonthView.prototype.getI18nValues = function() {
      var properties;
      properties = this.t(['sunday_short', 'monday_short', 'tuesday_short', 'wednesday_short', 'thursday_short', 'friday_short', 'saturday_short']);
      properties['i18n_previous_month_link'] = this.t('previous_month_link', [this.t('back_arrow')]);
      properties['i18n_next_month_link'] = this.t('next_month_link', [this.t('forward_arrow')]);
      return properties;
    };

    return MonthView;

  })(BH.Views.MainView);

  highlightBackward = function(startingWeekDay, $el) {
    var highlightedDays;
    highlightedDays = 1;
    while ($el.data('day').toLowerCase() !== startingWeekDay) {
      if ($el.is(':first-child')) {
        $el = $el.parent().prev().children().last();
      } else {
        $el = $el.prev();
      }
      $el.addClass('selected');
      highlightedDays += 1;
    }
    return highlightedDays;
  };

  highlightForward = function($el, highlightedDays) {
    var _results;
    _results = [];
    while (highlightedDays < 7) {
      if ($el.is(':last-child')) {
        $el = $el.parent().next().children().first();
      } else {
        $el = $el.next();
      }
      $el.addClass('selected');
      _results.push(highlightedDays += 1);
    }
    return _results;
  };

}).call(this);
