// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.NewTrailView = (function(_super) {

    __extends(NewTrailView, _super);

    function NewTrailView() {
      return NewTrailView.__super__.constructor.apply(this, arguments);
    }

    NewTrailView.include(BH.Modules.I18n);

    NewTrailView.prototype.className = 'new_trail_view';

    NewTrailView.prototype.template = BH.Templates['new_trail'];

    NewTrailView.prototype.events = {
      'click .cancel': 'cancelClicked',
      'click .build_trail': 'buildTrailClicked',
      'keyup [name=trail-matcher]': 'matcherKeyUp',
      'keyup [name=trail-name]': 'nameKeyUp',
      'click [name=add_matcher]': 'addMatcherClicked'
    };

    NewTrailView.prototype.initialize = function() {
      var _this = this;
      this.chromeAPI = chrome;
      this.tracker = analyticsTracker;
      this.model = new Backbone.Model({
        name: '',
        matchers: []
      });
      this.model.on('change:matchers', this.updateMatchers, this);
      return new BH.Lib.SearchHistory('').fetch({
        maxResults: 5000
      }, function(history, cacheDatetime) {
        if (cacheDatetime == null) {
          cacheDatetime = null;
        }
        return _this.historyCache = history;
      });
    };

    NewTrailView.prototype.render = function() {
      var html;
      html = Mustache.to_html(this.template, this.getI18nValues());
      this.$el.append(html);
      return this;
    };

    NewTrailView.prototype.matcherKeyUp = function(ev) {
      var matchPreviewView, matchedHistory, matcher, visit;
      matcher = $(ev.currentTarget).val();
      matchedHistory = (function() {
        var _i, _len, _ref, _results;
        _ref = this.historyCache;
        _results = [];
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          visit = _ref[_i];
          if (visit.location.match(matcher)) {
            _results.push(visit);
          }
        }
        return _results;
      }).call(this);
      matchPreviewView = new BH.Views.TrailMatchPreviewView({
        collection: new Backbone.Collection(matchedHistory),
        query: matcher
      });
      return this.$('.matched_visits').html(matchPreviewView.render().el);
    };

    NewTrailView.prototype.nameKeyUp = function(ev) {
      return this.model.set({
        name: $(ev.currentTarget).val()
      });
    };

    NewTrailView.prototype.addMatcherClicked = function(ev) {
      var $matcherInput, matcher, matchers;
      $matcherInput = this.$('[name=trail-matcher]');
      matcher = $matcherInput.val();
      $matcherInput.val('');
      this.$('.matched_visits').html('');
      matchers = _.clone(this.model.get('matchers'));
      matchers.push(matcher);
      return this.model.set({
        matchers: matchers
      });
    };

    NewTrailView.prototype.updateMatchers = function() {
      var matcher, _i, _len, _ref, _results;
      this.$('.matchers').html("<ul></ul>");
      _ref = this.model.get('matchers');
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        matcher = _ref[_i];
        _results.push(this.$('.matchers').append("<li><strong>" + matcher + "</strong><a href='#' style='float: right;'>Remove</a></li>"));
      }
      return _results;
    };

    NewTrailView.prototype.buildTrailClicked = function(ev) {
      ev.preventDefault();
      return this.trigger('build_trail', this.model);
    };

    NewTrailView.prototype.getI18nValues = function() {
      return this.t(['search_input_placeholder_text']);
    };

    return NewTrailView;

  })(BH.Views.MainView);

}).call(this);
