// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.SearchResultsView = (function(_super) {

    __extends(SearchResultsView, _super);

    function SearchResultsView() {
      return SearchResultsView.__super__.constructor.apply(this, arguments);
    }

    SearchResultsView.include(BH.Modules.I18n);

    SearchResultsView.prototype.template = BH.Templates['search_results'];

    SearchResultsView.prototype.events = {
      'click .delete_visit': 'deleteClicked'
    };

    SearchResultsView.prototype.initialize = function() {
      this.page = this.options.page;
      this.historian = this.options.historian;
      this.collection.on('add', this.onVisitAdded, this);
      return this.page.on('change:page', this.onPageChange, this);
    };

    SearchResultsView.prototype.render = function() {
      var end, html, presenter, properties, start, _ref;
      _ref = BH.Lib.Pagination.calculateBounds(this.page.get('page') - 1), start = _ref[0], end = _ref[1];
      presenter = new BH.Presenters.SearchHistoryPresenter(this.collection.toJSON(), this.options.query);
      properties = _.extend(this.getI18nValues(), {
        visits: presenter.history(start, end),
        extendSearch: this.page.get('totalPages') === this.page.get('page') && !this.options.deepSearched
      });
      html = Mustache.to_html(this.template, properties);
      this.$el.html(html);
      this.show();
      this.insertTags();
      this.attachDragging();
      this.inflateDates();
      return this;
    };

    SearchResultsView.prototype.resetRender = function() {
      var _this = this;
      this.hide();
      return setTimeout((function() {
        return _this.$('.visits_content').html('');
      }), 250);
    };

    SearchResultsView.prototype.show = function() {
      return this.$el.removeClass('disappear');
    };

    SearchResultsView.prototype.hide = function() {
      return this.$el.addClass('disappear');
    };

    SearchResultsView.prototype.inflateDates = function() {
      var end, history, presenter, start, _ref,
        _this = this;
      _ref = BH.Lib.Pagination.calculateBounds(this.page.get('page') - 1), start = _ref[0], end = _ref[1];
      presenter = new BH.Presenters.SearchHistoryPresenter(this.collection.toJSON(), this.options.query);
      history = presenter.history(start, end);
      return $('.visit .datetime').each(function(i, el) {
        return _this.inflateDate($(el), history[i].lastVisitTime);
      });
    };

    SearchResultsView.prototype.inflateDate = function($el, timestamp) {
      return $el.text(new Date(timestamp).toLocaleString(BH.lang));
    };

    SearchResultsView.prototype.insertTags = function() {
      return persistence.tag().cached(function(operations) {
        return $('.site').each(function() {
          var $el, activeTagsView, tags;
          $el = $(this);
          tags = operations.siteTags($el.attr('href'));
          activeTagsView = new BH.Views.ActiveTagsView({
            model: new BH.Models.Site({
              tags: tags
            }),
            editable: false
          });
          return $el.find('.active_tags').html(activeTagsView.render().el);
        });
      });
    };

    SearchResultsView.prototype.attachDragging = function() {
      var dragAndTagView;
      dragAndTagView = new BH.Views.DragAndTagView({
        model: this.model
      });
      dragAndTagView.render();
      return dragAndTagView.on('site:change', function(site, $el) {
        var activeTagsView;
        activeTagsView = new BH.Views.ActiveTagsView({
          model: new BH.Models.Site(site),
          editable: false
        });
        return $el.find('.active_tags').html(activeTagsView.render().el);
      });
    };

    SearchResultsView.prototype.deleteClicked = function(ev) {
      var $el, url,
        _this = this;
      ev.preventDefault();
      $el = $(ev.currentTarget);
      url = $el.data('url');
      return this.historian.deleteUrl(url, function() {
        $el.parents('.visit').remove();
        _this.collection.remove(_this.collection.where({
          url: url
        }));
        return window.analyticsTracker.searchResultDeletion();
      });
    };

    SearchResultsView.prototype.onVisitAdded = function(model) {
      var visitView;
      if ($('.visits li').length < 100) {
        visitView = new BH.Views.VisitView({
          model: model
        });
        this.$('.visits').append(visitView.render().el);
        return this.inflateDate(visitView.$('.datetime'), model.get('lastVisitTime'));
      }
    };

    SearchResultsView.prototype.onPageChange = function() {
      return this.render();
    };

    SearchResultsView.prototype.getI18nValues = function() {
      return this.t(['no_visits_found', 'prompt_delete_button']);
    };

    return SearchResultsView;

  })(Backbone.View);

}).call(this);
