//@ sourceMappingURL=syncing_decision_view.map
// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.SyncingDecisionView = (function(_super) {

    __extends(SyncingDecisionView, _super);

    function SyncingDecisionView() {
      return SyncingDecisionView.__super__.constructor.apply(this, arguments);
    }

    SyncingDecisionView.include(BH.Modules.I18n);

    SyncingDecisionView.prototype.className = 'syncing_decision_view';

    SyncingDecisionView.prototype.template = BH.Templates['syncing_decision'];

    SyncingDecisionView.prototype.events = {
      'click .push': 'pushClicked',
      'click .pull': 'pullClicked',
      'click .continue': 'continueClicked'
    };

    SyncingDecisionView.prototype.initialize = function() {
      this.chromeAPI = chrome;
      this.tracker = analyticsTracker;
      return this.attachGeneralEvents();
    };

    SyncingDecisionView.prototype.render = function() {
      this.$el.html(this.renderTemplate(this.getI18nValues()));
      this.tracker.syncDecisionModalSeen();
      return this;
    };

    SyncingDecisionView.prototype.pushClicked = function(ev) {
      ev.preventDefault();
      this.trigger('decision', 'push');
      return this.syncing();
    };

    SyncingDecisionView.prototype.pullClicked = function(ev) {
      ev.preventDefault();
      this.trigger('decision', 'pull');
      return this.syncing();
    };

    SyncingDecisionView.prototype.continueClicked = function(ev) {
      ev.preventDefault();
      this.close();
      return window.location.reload();
    };

    SyncingDecisionView.prototype.syncing = function() {
      this.$('.decision').hide();
      return this.$('.syncing').show();
    };

    SyncingDecisionView.prototype.doneSyncing = function() {
      this.$('.continue').removeAttr('disabled');
      this.$('.syncing').hide();
      this.$('.done_syncing').show();
      this.$('.website_plug').show();
      this.$('.continue').show();
      this.$('.title').remove();
      this.$('.content-area').css({
        marginTop: 26
      });
      return this.trigger('syncingComplete');
    };

    SyncingDecisionView.prototype.getI18nValues = function() {
      var properties;
      properties = this.t(['syncing_decision_title', 'syncing_push_button', 'syncing_pull_button', 'continue_button', 'initial_syncing_description']);
      properties.i18n_syncing_decision_description = this.t('syncing_decision_description', [this.model.get('numberOfSites'), '<strong>', '</strong>']);
      properties.i18n_initial_syncing_done = this.t('initial_syncing_done', ['<a href="http://www.better-history.com/me">', '</a>']);
      return properties;
    };

    return SyncingDecisionView;

  })(BH.Views.ModalView);

}).call(this);
