// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.TimelineView = (function(_super) {

    __extends(TimelineView, _super);

    function TimelineView() {
      return TimelineView.__super__.constructor.apply(this, arguments);
    }

    TimelineView.prototype.className = 'timeline_view';

    TimelineView.prototype.template = BH.Templates['timeline'];

    TimelineView.prototype.events = {
      'click a.date': 'onDateClicked',
      'click a.next': 'onNextClicked',
      'click a.previous': 'onPreviousClicked'
    };

    TimelineView.prototype.initialize = function() {
      this.state = new Backbone.Model({
        startDate: moment(new Date()).startOf('day').toDate()
      });
      return this.state.on('change:startDate', this.onStartDateChanged, this);
    };

    TimelineView.prototype.render = function() {
      var timelinePresenter;
      this.$el.html('');
      timelinePresenter = new BH.Presenters.Timeline(this.model.toJSON());
      this.$el.append(Mustache.to_html(this.template, timelinePresenter.timeline(this.state.get('startDate'))));
      return this;
    };

    TimelineView.prototype.onStartDateChanged = function() {
      return this.render();
    };

    TimelineView.prototype.onDateClicked = function(ev) {
      this.$('a').removeClass('selected');
      return $(ev.currentTarget).addClass('selected');
    };

    TimelineView.prototype.onNextClicked = function(ev) {
      var date;
      ev.preventDefault();
      if (!$(ev.currentTarget).hasClass('disabled')) {
        date = moment(this.state.get('startDate')).add('days', 7);
        return this.state.set({
          startDate: date.startOf('day').toDate()
        });
      }
    };

    TimelineView.prototype.onPreviousClicked = function(ev) {
      var date;
      ev.preventDefault();
      if (!$(ev.currentTarget).hasClass('disabled')) {
        date = moment(this.state.get('startDate')).subtract('days', 7);
        return this.state.set({
          startDate: date.startOf('day').toDate()
        });
      }
    };

    return TimelineView;

  })(BH.Views.MainView);

}).call(this);
