// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.VisitsResultsView = (function(_super) {

    __extends(VisitsResultsView, _super);

    function VisitsResultsView() {
      return VisitsResultsView.__super__.constructor.apply(this, arguments);
    }

    VisitsResultsView.include(BH.Modules.I18n);

    VisitsResultsView.prototype.template = BH.Templates['visits_results'];

    VisitsResultsView.prototype.events = {
      'click .delete_hour': 'deleteHourClicked',
      'click .delete_visit': 'deleteVisitClicked',
      'click .visit > a': 'visitClicked',
      'click .hours a': 'hourClicked'
    };

    VisitsResultsView.prototype.initialize = function() {
      return this.chromeAPI = chrome;
    };

    VisitsResultsView.prototype.render = function() {
      var date, hours, html, lastId, menuItems, presenter, properties, scrollItems, topMenu, topMenuHeight, visitsByHour;
      properties = this.getI18nValues();
      presenter = new BH.Presenters.VisitsPresenter();
      visitsByHour = presenter.visitsByHour(this.collection.toJSON());
      hours = presenter.hoursDistribution(this.collection.toJSON());
      if (this.collection.length > 0) {
        date = this.model.get('date');
        properties.history = {
          visitsByHour: visitsByHour.reverse(),
          date: date.toLocaleDateString('en'),
          day: moment(date).format('dddd'),
          hours: hours
        };
      }
      html = Mustache.to_html(this.template, properties);
      this.$el.html(html);
      document.body.scrollTop = 0;
      this.show();
      this.insertTags();
      this.attachDragging();
      this.inflateDates();
      this.$('.controls.hours a:not(.disabled)').eq(0).addClass('selected');
      lastId = null;
      topMenu = this.$('.hours');
      topMenuHeight = topMenu.outerHeight();
      menuItems = topMenu.find("a");
      scrollItems = menuItems.map(function() {
        return $($(this).attr("href"));
      });
      $(window).scroll(function() {
        var cur, fromTop, id, _ref;
        fromTop = document.body.scrollTop;
        cur = [];
        scrollItems.map(function(el) {
          var offsetTop;
          offsetTop = el.getBoundingClientRect().top + document.body.scrollTop - 205;
          if (offsetTop < fromTop) {
            return cur.push(el);
          }
        });
        id = (_ref = cur[cur.length - 1]) != null ? _ref.id : void 0;
        if (lastId !== id) {
          lastId = id;
          menuItems.removeClass("selected");
          menuItems.filter("[href='#" + id + "']").addClass("selected");
        }
      });
      return this;
    };

    VisitsResultsView.prototype.resetRender = function() {
      this.hide();
      return this.$('.visits_content').html('');
    };

    VisitsResultsView.prototype.show = function() {
      return this.$el.removeClass('disappear');
    };

    VisitsResultsView.prototype.hide = function() {
      return this.$el.addClass('disappear');
    };

    VisitsResultsView.prototype.inflateDates = function() {
      var _this = this;
      return $('.time').each(function(i, el) {
        var timestamp;
        timestamp = _this.collection.at(i).get('lastVisitTime');
        return $(el).text(new Date(timestamp).toLocaleTimeString(BH.lang));
      });
    };

    VisitsResultsView.prototype.insertTags = function() {
      return persistence.tag().cached(function(operations) {
        var _this = this;
        $('.site').each(function() {
          var $el, activeTagsView, tags;
          $el = $(this);
          tags = operations.siteTags($el.attr('href'));
          if (tags.length > 0) {
            activeTagsView = new BH.Views.ActiveTagsView({
              model: new BH.Models.Site({
                tags: tags
              }),
              editable: false
            });
            return $el.find('.active_tags').html(activeTagsView.render().el);
          }
        });
        return $('.grouped_sites').each(function(i, siteEl) {
          var $el, activeTagsView, sharedTags, urls;
          $el = $(siteEl);
          urls = [];
          $el.find('a.site').each(function() {
            return urls.push($(this).attr('href'));
          });
          sharedTags = operations.sitesTags(urls);
          activeTagsView = new BH.Views.ActiveTagsView({
            model: new BH.Models.Site({
              tags: sharedTags
            }),
            editable: false
          });
          return $el.find('.active_tags').eq(0).html(activeTagsView.render().el);
        });
      });
    };

    VisitsResultsView.prototype.attachDragging = function() {
      var dragAndTagView;
      dragAndTagView = new BH.Views.DragAndTagView({
        collection: this.collection
      });
      dragAndTagView.render();
      dragAndTagView.on('site:change', function(site, $el) {
        var activeTagsView;
        activeTagsView = new BH.Views.ActiveTagsView({
          model: new BH.Models.Site(site),
          editable: false
        });
        return $el.find('.active_tags').html(activeTagsView.render().el);
      });
      return dragAndTagView.on('sites:change', function(site, $el) {
        var $activeTags, activeTagsView;
        activeTagsView = new BH.Views.ActiveTagsView({
          model: new BH.Models.Site(site),
          editable: false
        });
        $activeTags = $el.children('.sites').find('.active_tags');
        return $activeTags.html(activeTagsView.render().el);
      });
    };

    VisitsResultsView.prototype.visitClicked = function(ev) {
      if ($(ev.target).hasClass('search_domain')) {
        ev.preventDefault();
        return router.navigate($(ev.target).attr('href'), {
          trigger: true
        });
      }
    };

    VisitsResultsView.prototype.hourClicked = function(ev) {
      var $el, $hour;
      ev.preventDefault();
      $el = $(ev.currentTarget);
      window.analyticsTracker.hourClick($el.data('hour'));
      $hour = $($el.attr('href'))[0];
      return document.body.scrollTop = $hour.getBoundingClientRect().top + document.body.scrollTop - 155;
    };

    VisitsResultsView.prototype.deleteHourClicked = function(ev) {
      var hour;
      ev.preventDefault();
      hour = $(ev.currentTarget).data('hour');
      return this.promptToDeleteHour(hour);
    };

    VisitsResultsView.prototype.deleteVisitClicked = function(ev) {
      var $el,
        _this = this;
      ev.preventDefault();
      $el = $(ev.currentTarget);
      analyticsTracker.visitDeletion();
      return Historian.deleteUrl($el.data('url'), function() {
        return $el.parent('.visit').remove();
      });
    };

    VisitsResultsView.prototype.promptToDeleteHour = function(hour) {
      var date, promptMessage, timestamp,
        _this = this;
      date = new Date(this.model.get('date'));
      date.setHours(hour);
      date.setSeconds(0);
      date.setMinutes(0);
      timestamp = date.toLocaleString(BH.lang);
      promptMessage = this.t('confirm_delete_all_visits', [timestamp]);
      this.promptView = BH.Views.CreatePrompt(promptMessage);
      this.promptView.open();
      return this.promptView.model.on('change', function(prompt) {
        return _this.promptAction(prompt, hour);
      }, this);
    };

    VisitsResultsView.prototype.promptAction = function(prompt, hour) {
      var dayHistorian;
      if (prompt.get('action')) {
        window.analyticsTracker.hourDeletion();
        dayHistorian = new Historian.Day(this.model.get('date'));
        return dayHistorian.destroyHour(hour, function() {
          return window.location.reload();
        });
      } else {
        return this.promptView.close();
      }
    };

    VisitsResultsView.prototype.getI18nValues = function() {
      return this.t(['prompt_delete_button', 'delete_time_interval_button', 'no_visits_found', 'expand_button', 'collapse_button', 'search_by_domain', 'delete_all_visits_for_filter_button']);
    };

    return VisitsResultsView;

  })(Backbone.View);

}).call(this);
