//@ sourceMappingURL=weeks_view.map
// Generated by CoffeeScript 1.6.1
(function() {
  var __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BH.Views.WeeksView = (function(_super) {

    __extends(WeeksView, _super);

    function WeeksView() {
      return WeeksView.__super__.constructor.apply(this, arguments);
    }

    WeeksView.include(BH.Modules.I18n);

    WeeksView.include(BH.Modules.Worker);

    WeeksView.prototype.template = BH.Templates['weeks'];

    WeeksView.prototype.className = 'week_view with_controls';

    WeeksView.prototype.events = {
      'click .delete_all': 'onDeleteAllClicked',
      'keyup .search': 'onSearchTyped',
      'blur .search': 'onSearchBlurred'
    };

    WeeksView.prototype.initialize = function() {
      this.chromeAPI = chrome;
      return this.collection.on('reset', this.renderHistory, this);
    };

    WeeksView.prototype.render = function() {
      var html, properties;
      properties = _.extend(this.getI18nValues());
      html = Mustache.to_html(this.template, properties);
      this.$el.html(html);
      return this;
    };

    WeeksView.prototype.onHistoryLoaded = function() {
      return this.renderHistory();
    };

    WeeksView.prototype.renderHistory = function() {
      var presenter, weeksResultsView;
      weeksResultsView = new BH.Views.WeeksResultsView({
        collection: this.collection
      });
      this.$('.content', this.$el).html(weeksResultsView.render().el);
      presenter = new BH.Presenters.AllWeeksPresenter(this.collection);
      this.$('.spinner').hide();
      this.$('.text.count').text("" + (presenter.totalVisits()) + " visits");
      return this.$('.text.count').css({
        opacity: 1
      });
    };

    WeeksView.prototype.onDeleteAllClicked = function() {
      return this.promptToDeleteAllVisits();
    };

    WeeksView.prototype.pageTitle = function() {
      return this.t('all_weeks_title');
    };

    WeeksView.prototype.promptToDeleteAllVisits = function() {
      var promptMessage;
      promptMessage = this.t('confirm_delete_all_weeks');
      this.promptView = BH.Views.CreatePrompt(promptMessage);
      this.promptView.open();
      return this.promptView.model.on('change', this.promptAction, this);
    };

    WeeksView.prototype.promptAction = function(prompt) {
      var _this = this;
      if (prompt.get('action')) {
        analyticsTracker.weekVisitsDeletion();
        return new BH.Chrome.WeeksHistory().destroy(function() {
          _this.promptView.close();
          return _this.collection.reset();
        });
      } else {
        return this.promptView.close();
      }
    };

    WeeksView.prototype.getI18nValues = function() {
      return this.t(['all_weeks_title', 'delete_all_weeks_button', 'no_visits_found', 'search_input_placeholder_text']);
    };

    return WeeksView;

  })(BH.Views.MainView);

}).call(this);
