﻿var lastnewtabid = new Object();
var focustabid = null;
var bCreating = false;

function OnWindowCreated(wnd)
{
	if(wnd.type != "normal"){
		return;
	}
	
	chrome.tabs.getAllInWindow(wnd.id, function(tabs) {
		if(tabs.length != 1){
			return;
		}
		if(tabs[0].url != "chrome://newtab/"){
			chrome.tabs.create({
				url:'chrome://newtab/',
				selected:false
			});
			focustabid = tabs[0].id;
		}
	});
}

function OnTabCreated(tab)
{
	if(tab.url == "chrome://newtab/"){
		lastnewtabid[tab.windowId] = tab.id;
		bCreating = false;
	}
}

function OnTabRemoved(tabId)
{
	var closable = localStorage["can_close_new_tab"];
	if(!closable){
		closable = "true";
	}
	
	chrome.windows.getCurrent(function(wnd) {
		if(!wnd){
			return;
		}
		chrome.tabs.getAllInWindow(wnd.id, function(tabs) {
			if(!tabs){
				return;
			}
			
			if(closable == "true"){
				if(tabs.length == 2){
					if(tabs[1].url == "chrome://newtab/"){
						lastnewtabid[wnd.id] = tabs[1].id;
					}
				}
				
				if(tabId == lastnewtabid[wnd.id]){
					lastnewtabid[wnd.id] = null;
					return;
				}
			}
			
			if(tabs.length == 1){
				if(tabs[0].url == "chrome://newtab/"){
					return;
				}
				if(bCreating == true){
					return;
				}
				bCreating = true;
				chrome.tabs.create({
					url:'chrome://newtab/',
					selected:false
				});
				focustabid = tabs[0].id;
			}
		});
	});
}

function OnTabAttached(tabId, attachInfo)
{
	var autoclose = localStorage["automatic_close"];
	if(!autoclose){
		autoclose = "true";
	}	
	
	chrome.tabs.getAllInWindow(attachInfo.oldWindowId, function(tabs) {
		if(!tabs){
			return;
		}
		
		if(autoclose == "true"){
			var i;
			var webpages = 0;
			var newtabs = new Array();
			
			for(i = 0; i < tabs.length; i++)
			{
				if(tabs[i].url != "chrome://newtab/"){
					webpages++;
				}else{
					newtabs.push(tabs[i].id);
				}
			}
			
			if(webpages >= 2 && newtabs.length > 0){
				for(i = 0; i < newtabs.length; i++){
					chrome.tabs.remove(newtabs[i]);
				}
			}
		}
	});	
}

function OnTabDetached(tabId, detachInfo)
{
	chrome.tabs.getAllInWindow(detachInfo.oldWindowId, function(tabs) {
		if(!tabs){
			return;
		}
		
		if(tabs.length == 1){
			if(tabs[0].url != "chrome://newtab/"){
				chrome.tabs.create({
					url:'chrome://newtab/',
					selected:false
				});	
				focustabid = tabs[0].id;
			}
		}
	});
}

function OnTabUpdated(tabId, changeInfo, tab)
{
	if(!changeInfo.url){
		return;
	}
	if(changeInfo.url == "chrome://newtab/"){
		if(focustabid != null){
			chrome.tabs.update(focustabid, { selected: true });
			focustabid = null;
		}
		return;
	}
	
	var autoclose = localStorage["automatic_close"];
	if(!autoclose){
		autoclose = "true";
	}
	
	if(tab){
		chrome.windows.get(tab.windowId, function(wnd){
			if(!wnd){
				return;
			}
			
			if(wnd.type != "normal"){
				return;
			}
			
			if(tab.url != "chrome://newtab/"){
				lastnewtabid[tab.windowId] = null;				
			}
			
			chrome.tabs.getAllInWindow(tab.windowId, function(tabs) {
				if(!tabs){
					return;
				}
				
				if(tabs.length == 1){
					if(tabs[0].url != "chrome://newtab/"){
						bCreating = true;
						chrome.tabs.create({
							url:'chrome://newtab/',
							selected:false
						});	
						focustabid = tabs[0].id;
						return;
					}
				}
				
				if(tabs.length == 2){
					return;
				}
				
				if(autoclose == "true"){
					var i;
					var webpages = 0;
					var newtabs = new Array();
					
					for(i = 0; i < tabs.length; i++)
					{
						if(tabs[i].url != "chrome://newtab/"){
							webpages++;
						}else{
							newtabs.push(tabs[i].id);
						}
					}
					
					if(webpages >= 2 && newtabs.length > 0){
						for(i = 0; i < newtabs.length; i++){
							chrome.tabs.remove(newtabs[i]);
						}
					}
				}
			});
		});
	}	
}

chrome.windows.onCreated.addListener(OnWindowCreated);
chrome.tabs.onCreated.addListener(OnTabCreated);
chrome.tabs.onRemoved.addListener(OnTabRemoved);
chrome.tabs.onAttached.addListener(OnTabAttached);
chrome.tabs.onDetached.addListener(OnTabDetached);
chrome.tabs.onUpdated.addListener(OnTabUpdated);