﻿// Initialize
function initialize() {
  load_messages();
  restore_options();
}

// Load localized String
function load_messages() {
  var message;
  message = chrome.i18n.getMessage("optNewTabcCosable");
  document.getElementById("txtNewTabClosabel").innerHTML = message;
  message = chrome.i18n.getMessage("optAutomaticClose");
  document.getElementById("txtAutomaticClose").innerHTML = message;
}

// Saves options to localStorage.
function save_options() {
  var closable = document.getElementById("newtabclosable").checked;
  var autoclose = document.getElementById("automatic_close").checked;
  localStorage["can_close_new_tab"] = closable;
  localStorage["automatic_close"] = autoclose;

  // Update status to let user know options were saved.
  var status = document.getElementById("status");
  status.innerHTML = "Options Saved.";
  setTimeout(function() {
    status.innerHTML = "";
  }, 1000);
}

// Restores select box state to saved value from localStorage.
function restore_options() {
  var closable = localStorage["can_close_new_tab"];
  if (!closable) {
  	closable = "true";
	localStorage["can_close_new_tab"] = closable;
  }
  if (closable == "true") {
    document.getElementById("newtabclosable").checked = true;
  }  

  var autoclose = localStorage["automatic_close"];
  if (!autoclose) {
  	autoclose = "true";
	localStorage["automatic_close"] = closable;
  }
  if (autoclose == "true") {
    document.getElementById("automatic_close").checked = true;
  }   
}

document.addEventListener('DOMContentLoaded', function () {
  initialize();
  document.querySelector('button').addEventListener('click', save_options);
});
