﻿/**
 * @author: Mitsuaki Ishimoto
 * @see: http://blog.justoneplanet.info/
/*=================================================================*/
$(function(){
    /**
     * クリック時の動作を定義
     * set up event, clicking kaomojis
     */
    var clickedFunc = function(face, tag, width, isSavedHistory){
        $('span.copied').fadeOut(0);
        console.log(face);
        var lines = face.split('\n').length;
        document.querySelector('textarea.selected').setAttribute('rows', lines);
        $('textarea.selected').val(face);
        $('textarea.selected').focus();
        $('textarea.selected').select();
        $('textarea.selected').css({
            "width" : width + 20 + 'px'
        });
        document.execCommand("Copy");
        if (isSavedHistory) {
            chrome.extension.sendRequest({
                "action"    : "kaomoji.addHistory",
                "face"      : face,
                "tag"       : tag
            }, function () {
            });
        }
        $('textarea.selected').blur();
        $('span.copied').fadeIn(250);
    };
    
    /**
     * 右クリック時の動作を定義（jQuery pluginを使用）
     */
    var contextMenuOption = {
        "menuStyle" : {
            "width": "150px"
        },
        "bindings" : {
            "favorite" : function(elm){
                var face = elm.getAttribute('data-face');
                var tag = elm.getAttribute('data-tag');
                chrome.extension.sendRequest({
                    "action"    : "kaomoji.addFavorite",
                    "timeStamp" : Date.now(),
                    "face"      : face,
                    "tag"       : tag
                }, function () {
                });
                chrome.extension.sendRequest({
                    "action"  : "log",
                    "kaomoji" : face
                });
                chrome.extension.sendRequest(
                    {"action" : "resetMenu"},
                    function(parent){
                    }
                );
            },
            "delete" : function(elm){
                chrome.extension.sendRequest({
                    "action" : "kaomoji.deleteFavorite",
                    "key"    : $(elm).attr('id')
                }, function (key) {
                    if (key) {
                        $('div#tab-6 ul #' + key).fadeOut(
                            150,
                            function(){
                                $(this).remove();
                                kaomoji.getAllFavorite();
                            }
                        );
                    }
                });
                chrome.extension.sendRequest(
                    {"action" : "resetMenu"},
                    function(parent){
                    }
                );
            }
        },
        "onShowMenu" : function(e, menu){
            if($(e.target).closest('div').is('#tab-6')){
                $('li#favorite', menu).remove();
            }
            else{
                $('li#delete', menu).remove();
            }
            return menu;
        }
    };
    
    /**
     * list要素の生成
     */
    var getRenderElement = function (row) {
        var text = document.createTextNode(row.face);
        var a  = document.createElement('a');
        var li = document.createElement('li');
        a.setAttribute('class', 'kaomoji');
        a.setAttribute('id',        row.timeStamp);
        a.setAttribute('title',     row.tag);
        a.setAttribute('data-face', row.face);
        a.setAttribute('data-tag',  row.tag);
        a.appendChild(text);
        a.innerHTML = a.innerHTML.replace(/\n/ig, '<br>');
        li.appendChild(a);
        return li;
    }
    
    /**
     * set up tabs
     */
    $("#tabs").tabs({
        "selected" : 4
    });
    
    /**
     * お気に入りのタブのload
     */
    var loadFavorite = function () {
        chrome.extension.sendRequest({
            "action"    : "kaomoji.getAllFavorite"
        }, function (ary) {
            $('div#tab-6 ul').empty();
            var df = document.createDocumentFragment();
            ary.forEach(function (e, i, ary) {
                var li = getRenderElement(e);
                if (df.firstChild) {
                    df.insertBefore(
                        li,
                        df.firstChild
                    );
                }
                else {
                    df.appendChild(li);
                }
            });
            document.querySelector('div#tab-6 ul').appendChild(df);
            $('div#tab-6 ul a.kaomoji').contextMenu('contextmenu1', contextMenuOption);// コンテキストメニュー付加
            $('div#tab-6 ul a.kaomoji').click(function () {
                var face = $(this).attr('data-face');
                var tag  = $(this).attr('data-tag');
                clickedFunc(face, tag, this.offsetWidth, false);
            });// クリックしたときの機能を付加
        });
    }
    loadFavorite();
    
    /**
     * block the click on the textarea.selected
     */
    $('textarea.selected').click(function(){
        this.blur();
    });
    $('textarea.selected').mousedown(function(){
        this.blur();
    });
    
    $('a.kaomoji').click(function () {
        var face = $(this).attr('data-face');
        var tag  = $(this).attr('data-tag');
        clickedFunc(face, tag, this.offsetWidth, true);
    });
    $('a.kaomoji').contextMenu('contextmenu1', contextMenuOption);
    
    /**
     * set a event to register faces
     */
    $('input[name="register"]').click(function(){
        var face = $('input[name="face"]').val();
        var tag  = $('input[name="tag"]').val();
        if(face !== '' && tag !== ''){
            chrome.extension.sendRequest({
                "action"    : "kaomoji.addFavorite",
                "timeStamp" : Date.now(),
                "face"      : face,
                "tag"       : tag
            }, function () {
            });
            
            var xhr = createXHR("POST", "http://kaomoji.justoneplanet.info/emoticons/add", true);
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xhr.onreadystatechange = function() {
                if(xhr.readyState === 4){
                }
            }
            xhr.send("face=" + encodeURIComponent(face) + "&tag=" + encodeURIComponent(tag));            
        }
        else{
            return false;
        }
        $('div#tab-6 ul').fadeOut(
            150,
            function(){
                $(this).fadeIn(0);
            	var text = document.createTextNode(face);
            	var a  = document.createElement('a');
            	var li = document.createElement('li');
                a.setAttribute('class', 'kaomoji');
                a.setAttribute('title', tag);
                a.setAttribute('data-face', face);
                a.setAttribute('data-tag', tag);
            	a.appendChild(text);
            	li.appendChild(a);
                $(a).contextMenu('contextmenu1', contextMenuOption);// コンテキストメニュー付加
                $(a).click(function () {
                    var face = $(this).attr('data-face');
                    var tag  = $(this).attr('data-tag');
                    clickedFunc(face, tag, this.offsetWidth, true);
                });// クリックしたときの機能を付加
                $('div#tab-6 ul').append(li);
            }
        );
    });
    
    /**
     * load favorite tab
     * お気に入りのタブを選択したとき
     */
    $('a[href="#tab-6"]').click(function(){
        loadFavorite();
    });
    
    /**
     * load everyone's faces
     * みんなのかおもじをクリックしたとき
     */
    var flag = true;
    $('a[href="#tab-7"]').click(function(){
        if(flag){
            var loader = document.createElement('p');
            loader.appendChild(document.createTextNode('loading...'));
            loader.className = 'loader';
            var xhr = createXHR("GET", "http://kaomoji.justoneplanet.info/emoticons/get", true);
            xhr.onreadystatechange = function(){
                if(xhr.readyState === 4){
                    $('div#tab-7 ul').empty();
                    var data = JSON.parse(xhr.responseText);
                    var df   = document.createDocumentFragment();
                    for(var i = 0, n = data.length; i < n; i++){
                    	var text = document.createTextNode(data[i]['face']);
                    	var a  = document.createElement('a');
                    	var li = document.createElement('li');
                        a.setAttribute('class', 'kaomoji');
                        a.setAttribute('title', data[i]['tag']);
                        a.setAttribute('data-face', data[i]['face']);
                        a.setAttribute('data-tag', data[i]['tag']);
                    	a.appendChild(text);
                    	li.appendChild(a);
                    	df.appendChild(li);
                        a.innerHTML = a.innerHTML.replace(/\n/ig, '<br>');
                    }
                    document.querySelector('div#tab-7 ul').appendChild(df);
                    $('div#tab-7 ul a.kaomoji').contextMenu('contextmenu1', contextMenuOption);// コンテキストメニュー付加
                    $('div#tab-7 ul a.kaomoji').click(function () {
                        var face = $(this).attr('data-face');
                        var tag  = $(this).attr('data-tag');
                        clickedFunc(face, tag, this.offsetWidth, true);
                    });// クリックしたときの機能を付加
                    flag = false;
                }
            }
            $('div#tab-7 ul').append(loader);
            xhr.send();
        }
    });
    
    /**
     * set a event to search faces
     * 検索ボタンをクリックしたとき
     */
    $('input[name="search"]').click(function(){
        var word = $('input[name="word"]').val();
        var xhr = createXHR("GET", "http://kaomoji.justoneplanet.info/emoticons/get?word=" + encodeURIComponent(word), true);
        xhr.onreadystatechange = function(){
            if(xhr.readyState === 4){
                $('div#tab-7 ul').empty();
                var data = JSON.parse(xhr.responseText);
                var df   = document.createDocumentFragment();
                for(var i = 0, n = data.length; i < n; i++){
                	var text = document.createTextNode(data[i]['face']);
                	var a  = document.createElement('a');
                	var li = document.createElement('li');
                    a.setAttribute('class', 'kaomoji');
                    a.setAttribute('title', data[i]['tag']);
                    a.setAttribute('data-face', data[i]['face']);
                    a.setAttribute('data-tag', data[i]['tag']);
                	a.appendChild(text);
                	li.appendChild(a);
                	df.appendChild(li);
                    a.innerHTML = a.innerHTML.replace(/\n/ig, '<br>');
                }
                document.querySelector('div#tab-7 ul').appendChild(df);
                $('div#tab-7 ul a.kaomoji').contextMenu('contextmenu1', contextMenuOption);// コンテキストメニュー付加
                $('div#tab-7 ul a.kaomoji').click(function () {
                    var face = $(this).attr('data-face');
                    var tag  = $(this).attr('data-tag');
                    clickedFunc(face, tag, this.offsetWidth, true);
                });// クリックしたときの機能を付加
                flag = false;
            }
        }
        xhr.send();
    });
    
    /**
     * 検索テキストエリアフォーカス時にenterが押されたとき
     */
    $('input[name="word"]').keydown(function(e){
        if(e.keyCode === 13){
            var word = $('input[name="word"]').val();
            var xhr = createXHR("GET", "http://kaomoji.justoneplanet.info/emoticons/get?word=" + encodeURIComponent(word), true);
            xhr.onreadystatechange = function(){
                if(xhr.readyState === 4){
                    $('div#tab-7 ul').empty();
                    var data = JSON.parse(xhr.responseText);
                    var df   = document.createDocumentFragment();
                    for(var i = 0, n = data.length; i < n; i++){
                    	var text = document.createTextNode(data[i]['face']);
                    	var a  = document.createElement('a');
                    	var li = document.createElement('li');
                        a.setAttribute('class', 'kaomoji');
                        a.setAttribute('title', data[i]['tag']);
                        a.setAttribute('data-face', data[i]['face']);
                        a.setAttribute('data-tag', data[i]['tag']);
                    	a.appendChild(text);
                    	li.appendChild(a);
                    	df.appendChild(li);
                        a.innerHTML = a.innerHTML.replace(/\n/ig, '<br>');
                    }
                    document.querySelector('div#tab-7 ul').appendChild(df);
                    $('div#tab-7 ul a.kaomoji').contextMenu('contextmenu1', contextMenuOption);// コンテキストメニュー付加
                    $('div#tab-7 ul a.kaomoji').click(function () {
                        var face = $(this).attr('data-face');
                        var tag  = $(this).attr('data-tag');
                        clickedFunc(face, tag, this.offsetWidth, true);
                    });// クリックしたときの機能を付加
                    flag = false;
                }
            }
            xhr.send();
        }
    });
    
    /**
     * load ranking faces
     */
    var flagRank = true;
    $('a[href="#tab-8"]').click(function(){
        if(flagRank){
            var loader = document.createElement('p');
            loader.appendChild(document.createTextNode('loading...'));
            $(loader).css({});
            loader.className  = 'loader';
            var xhr = createXHR("GET", "http://kaomoji.justoneplanet.info/logs/rank", true);
            xhr.onreadystatechange = function(){
                if(xhr.readyState === 4){
                    $('div#tab-8 ul').empty();
                    var data = JSON.parse(xhr.responseText);
                    var df   = document.createDocumentFragment();
                    for(var i = 0, n = data.length; i < n; i++){
                        var text = document.createTextNode(data[i]['face']);
                        var a  = document.createElement('a');
                        var span = document.createElement('span');
                        span.setAttribute('class', 'no');
                        span.appendChild(document.createTextNode('No.' + (i + 1)));
                        var li = document.createElement('li');
                        a.setAttribute('class', 'kaomoji');
                        a.setAttribute('title', data[i]['tag']);
                        a.setAttribute('data-face', data[i]['face']);
                        a.setAttribute('data-tag', data[i]['tag']);
                        a.appendChild(text);
                        li.appendChild(span);
                        li.appendChild(a);
                        df.appendChild(li);
                        a.innerHTML = a.innerHTML.replace(/\n/ig, '<br>');
                        if(i === 0){
                            li.setAttribute('class', 'best');
                        }
                        else if(i < 10){
                            li.setAttribute('class', 'best10');
                        }
                        else{
                            li.setAttribute('class', 'best30');
                        }
                    }
                    document.querySelector('div#tab-8 ul').appendChild(df);
                    $('div#tab-8 ul a.kaomoji').contextMenu('contextmenu1', contextMenuOption);// コンテキストメニュー付加
                    $('div#tab-8 ul a.kaomoji').click(function () {
                        var face = $(this).attr('data-face');
                        var tag  = $(this).attr('data-tag');
                        clickedFunc(face, tag, this.offsetWidth, true);
                    });// クリックしたときの機能を付加
                    flagRank = false;
                }
            }
            $('div#tab-8 ul').append(loader);
            xhr.send();            
        }
    });
    
    /**
     * 履歴タブが選択された時
     */
    $('a[href="#tab-9"]').click(function(){
        chrome.extension.sendRequest({
            "action"    : "kaomoji.getAllHistory"
        }, function (ary) {
            $('div#tab-9 ul').empty();
            var df = document.createDocumentFragment();
            ary.forEach(function (e, i, ary) {
                var li = getRenderElement(e);
                if (df.firstChild) {
                    df.insertBefore(
                        li,
                        df.firstChild
                    );
                }
                else {
                    df.appendChild(li);
                }
            });
            document.querySelector('div#tab-9 ul').appendChild(df);
            $('div#tab-9 ul a.kaomoji').contextMenu('contextmenu1', contextMenuOption);// コンテキストメニュー付加
            $('div#tab-9 ul a.kaomoji').click(function () {
                var face = $(this).attr('data-face');
                var tag  = $(this).attr('data-tag');
                clickedFunc(face, tag, this.offsetWidth, false);
            });// クリックしたときの機能を付加
        });
    });
});
var createXHR = function(method, url, async) {
    var xhr = new XMLHttpRequest();
    xhr.open(method, url, async);
    xhr.setRequestHeader('Kaomoji-Version', '1');
	return xhr;
}
